require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FENV_H_)) {
    eval 'sub _FENV_H_ () {1;}' unless defined(&_FENV_H_);
    require 'sys/_types.ph';
    unless(defined(&__fenv_static)) {
	eval 'sub __fenv_static () { &static;}' unless defined(&__fenv_static);
    }
    eval 'sub FE_INVALID () {0x1;}' unless defined(&FE_INVALID);
    eval 'sub FE_DIVBYZERO () {0x2;}' unless defined(&FE_DIVBYZERO);
    eval 'sub FE_OVERFLOW () {0x4;}' unless defined(&FE_OVERFLOW);
    eval 'sub FE_UNDERFLOW () {0x8;}' unless defined(&FE_UNDERFLOW);
    eval 'sub FE_INEXACT () {0x10;}' unless defined(&FE_INEXACT);
    if(defined(&__ARM_PCS_VFP)) {
	eval 'sub FE_DENORMAL () {0x80;}' unless defined(&FE_DENORMAL);
	eval 'sub FE_ALL_EXCEPT () {( &FE_DIVBYZERO |  &FE_INEXACT |  &FE_INVALID |  &FE_OVERFLOW |  &FE_UNDERFLOW |  &FE_DENORMAL);}' unless defined(&FE_ALL_EXCEPT);
    } else {
	eval 'sub FE_ALL_EXCEPT () {( &FE_DIVBYZERO |  &FE_INEXACT |  &FE_INVALID |  &FE_OVERFLOW |  &FE_UNDERFLOW);}' unless defined(&FE_ALL_EXCEPT);
    }
    eval 'sub VFP_FE_TONEAREST () {0x;}' unless defined(&VFP_FE_TONEAREST);
    eval 'sub VFP_FE_UPWARD () {0x400000;}' unless defined(&VFP_FE_UPWARD);
    eval 'sub VFP_FE_DOWNWARD () {0x800000;}' unless defined(&VFP_FE_DOWNWARD);
    eval 'sub VFP_FE_TOWARDZERO () {0xc00000;}' unless defined(&VFP_FE_TOWARDZERO);
    if(defined(&__ARM_PCS_VFP)) {
	eval 'sub FE_TONEAREST () { &VFP_FE_TONEAREST;}' unless defined(&FE_TONEAREST);
	eval 'sub FE_UPWARD () { &VFP_FE_UPWARD;}' unless defined(&FE_UPWARD);
	eval 'sub FE_DOWNWARD () { &VFP_FE_DOWNWARD;}' unless defined(&FE_DOWNWARD);
	eval 'sub FE_TOWARDZERO () { &VFP_FE_TOWARDZERO;}' unless defined(&FE_TOWARDZERO);
    } else {
	eval 'sub FE_TONEAREST () {0x;}' unless defined(&FE_TONEAREST);
	eval 'sub FE_TOWARDZERO () {0x1;}' unless defined(&FE_TOWARDZERO);
	eval 'sub FE_UPWARD () {0x2;}' unless defined(&FE_UPWARD);
	eval 'sub FE_DOWNWARD () {0x3;}' unless defined(&FE_DOWNWARD);
    }
    eval 'sub _ROUND_MASK () {( &FE_TONEAREST |  &FE_DOWNWARD |  &FE_UPWARD |  &FE_TOWARDZERO);}' unless defined(&_ROUND_MASK);
    eval 'sub FE_DFL_ENV () {(& &__fe_dfl_env);}' unless defined(&FE_DFL_ENV);
    unless(defined(&__ARM_PCS_VFP)) {
	eval 'sub _FPUSW_SHIFT () {16;}' unless defined(&_FPUSW_SHIFT);
	eval 'sub _ENABLE_MASK () {( &FE_ALL_EXCEPT <<  &_FPUSW_SHIFT);}' unless defined(&_ENABLE_MASK);
    }
    unless(defined(&__ARM_PCS_VFP)) {
	if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	}
    } else {
	eval 'sub vmrs_fpscr {
	    my($__r) = @_;
    	    eval q( &__asm  &__volatile(\\"vmrs %0, fpscr\\" : \\"=&r\\"($__r)));
	}' unless defined(&vmrs_fpscr);
	eval 'sub vmsr_fpscr {
	    my($__r) = @_;
    	    eval q( &__asm  &__volatile(\\"vmsr fpscr, %0\\" : : \\"r\\"($__r)));
	}' unless defined(&vmsr_fpscr);
	eval 'sub _FPU_MASK_SHIFT () {8;}' unless defined(&_FPU_MASK_SHIFT);
	if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	}
    }
}
1;
