require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ASM_H_)) {
    eval 'sub _MACHINE_ASM_H_ () {1;}' unless defined(&_MACHINE_ASM_H_);
    require 'sys/cdefs.ph';
    require 'machine/sysreg.ph';
    eval 'sub _C_LABEL {
        my($x) = @_;
	    eval q($x);
    }' unless defined(&_C_LABEL);
    eval 'sub _ASM_LABEL {
        my($x) = @_;
	    eval q($x);
    }' unless defined(&_ASM_LABEL);
    unless(defined(&_ALIGN_TEXT)) {
	eval 'sub _ALIGN_TEXT () {. &align 2;}' unless defined(&_ALIGN_TEXT);
    }
    unless(defined(&_STANDALONE)) {
	eval 'sub STOP_UNWINDING () {. &cantunwind;}' unless defined(&STOP_UNWINDING);
	eval 'sub _FNSTART () {. &fnstart;}' unless defined(&_FNSTART);
	eval 'sub _FNEND () {. &fnend;}' unless defined(&_FNEND);
	eval 'sub _SAVE () {(...) . &save  &__VA_ARGS__;}' unless defined(&_SAVE);
    } else {
	eval 'sub STOP_UNWINDING () {1;}' unless defined(&STOP_UNWINDING);
	eval 'sub _FNSTART () {1;}' unless defined(&_FNSTART);
	eval 'sub _FNEND () {1;}' unless defined(&_FNEND);
	eval 'sub _SAVE () {(...);}' unless defined(&_SAVE);
    }
    eval 'sub _ASM_TYPE_FUNCTION () { &function;}' unless defined(&_ASM_TYPE_FUNCTION);
    eval 'sub _ASM_TYPE_OBJECT () { &object;}' unless defined(&_ASM_TYPE_OBJECT);
    if(defined(&GPROF)) {
	eval 'sub _PROF_PROLOGUE () { &mov  &ip,  &lr;  &bl  &__mcount;}' unless defined(&_PROF_PROLOGUE);
    } else {
	eval 'sub _PROF_PROLOGUE () {1;}' unless defined(&_PROF_PROLOGUE);
    }
    eval 'sub GLOBAL {
        my($x) = @_;
	    eval q(. &global $x);
    }' unless defined(&GLOBAL);
    if(defined(&__thumb__)) {
	eval 'sub _FUNC_MODE () {. &code 16; . &thumb_func;}' unless defined(&_FUNC_MODE);
    } else {
	eval 'sub _FUNC_MODE () {. &code 32;}' unless defined(&_FUNC_MODE);
    }
    eval 'sub _LEENTRY {
        my($x) = @_;
	    eval q(. &type $x, &_ASM_TYPE_FUNCTION;  &_FUNC_MODE; $x:);
    }' unless defined(&_LEENTRY);
    eval 'sub _LEEND {
        my($x) = @_;
	    eval q();
    }' unless defined(&_LEEND);
    eval 'sub _EENTRY {
        my($x) = @_;
	    eval q( &GLOBAL($x);  &_LEENTRY($x));
    }' unless defined(&_EENTRY);
    eval 'sub _EEND {
        my($x) = @_;
	    eval q( &_LEEND($x));
    }' unless defined(&_EEND);
    eval 'sub _LENTRY {
        my($x) = @_;
	    eval q(. &text;  &_ALIGN_TEXT;  &_LEENTRY($x);  &_FNSTART);
    }' unless defined(&_LENTRY);
    eval 'sub _LEND {
        my($x) = @_;
	    eval q(. &size $x, . - $x;  &_FNEND);
    }' unless defined(&_LEND);
    eval 'sub _ENTRY {
        my($x) = @_;
	    eval q(. &text;  &_ALIGN_TEXT;  &_EENTRY($x);  &_FNSTART);
    }' unless defined(&_ENTRY);
    eval 'sub _END {
        my($x) = @_;
	    eval q( &_LEND($x));
    }' unless defined(&_END);
    eval 'sub ENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_C_LABEL($y));  &_PROF_PROLOGUE);
    }' unless defined(&ENTRY);
    eval 'sub EENTRY {
        my($y) = @_;
	    eval q( &_EENTRY( &_C_LABEL($y)););
    }' unless defined(&EENTRY);
    eval 'sub ENTRY_NP {
        my($y) = @_;
	    eval q( &_ENTRY( &_C_LABEL($y)));
    }' unless defined(&ENTRY_NP);
    eval 'sub EENTRY_NP {
        my($y) = @_;
	    eval q( &_EENTRY( &_C_LABEL($y)));
    }' unless defined(&EENTRY_NP);
    eval 'sub END {
        my($y) = @_;
	    eval q( &_END( &_C_LABEL($y)));
    }' unless defined(&END);
    eval 'sub EEND {
        my($y) = @_;
	    eval q( &_EEND( &_C_LABEL($y)));
    }' unless defined(&EEND);
    eval 'sub ASENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($y));  &_PROF_PROLOGUE);
    }' unless defined(&ASENTRY);
    eval 'sub ASLENTRY {
        my($y) = @_;
	    eval q( &_LENTRY( &_ASM_LABEL($y));  &_PROF_PROLOGUE);
    }' unless defined(&ASLENTRY);
    eval 'sub ASEENTRY {
        my($y) = @_;
	    eval q( &_EENTRY( &_ASM_LABEL($y)););
    }' unless defined(&ASEENTRY);
    eval 'sub ASLEENTRY {
        my($y) = @_;
	    eval q( &_LEENTRY( &_ASM_LABEL($y)););
    }' unless defined(&ASLEENTRY);
    eval 'sub ASENTRY_NP {
        my($y) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($y)));
    }' unless defined(&ASENTRY_NP);
    eval 'sub ASLENTRY_NP {
        my($y) = @_;
	    eval q( &_LENTRY( &_ASM_LABEL($y)));
    }' unless defined(&ASLENTRY_NP);
    eval 'sub ASEENTRY_NP {
        my($y) = @_;
	    eval q( &_EENTRY( &_ASM_LABEL($y)));
    }' unless defined(&ASEENTRY_NP);
    eval 'sub ASLEENTRY_NP {
        my($y) = @_;
	    eval q( &_LEENTRY( &_ASM_LABEL($y)));
    }' unless defined(&ASLEENTRY_NP);
    eval 'sub ASEND {
        my($y) = @_;
	    eval q( &_END( &_ASM_LABEL($y)));
    }' unless defined(&ASEND);
    eval 'sub ASLEND {
        my($y) = @_;
	    eval q( &_LEND( &_ASM_LABEL($y)));
    }' unless defined(&ASLEND);
    eval 'sub ASEEND {
        my($y) = @_;
	    eval q( &_EEND( &_ASM_LABEL($y)));
    }' unless defined(&ASEEND);
    eval 'sub ASLEEND {
        my($y) = @_;
	    eval q( &_LEEND( &_ASM_LABEL($y)));
    }' unless defined(&ASLEEND);
    eval 'sub ASMSTR () {. &asciz;}' unless defined(&ASMSTR);
    if(defined(&PIC)) {
	eval 'sub PLT_SYM {
	    my($x) = @_;
    	    eval q( &PIC_SYM($x,  &PLT));
	}' unless defined(&PLT_SYM);
	eval 'sub GOT_SYM {
	    my($x) = @_;
    	    eval q( &PIC_SYM($x,  &GOT));
	}' unless defined(&GOT_SYM);
	eval 'sub GOT_GET {
	    my($x,$got,$sym) = @_;
    	    eval q( &ldr $x, $sym;  &ldr $x, [$x, $got]);
	}' unless defined(&GOT_GET);
	eval 'sub GOT_INIT {
	    my($got,$gotsym,$pclabel) = @_;
    	    eval q( &ldr $got, $gotsym; $pclabel:  &add $got,  &pc);
	}' unless defined(&GOT_INIT);
	if(defined(&__thumb__)) {
	    eval 'sub GOT_INITSYM {
	        my($gotsym,$pclabel) = @_;
    		eval q(. &align 2; $gotsym: . &word  &_C_LABEL( &_GLOBAL_OFFSET_TABLE_) - ($pclabel+4));
	    }' unless defined(&GOT_INITSYM);
	} else {
	    eval 'sub GOT_INITSYM {
	        my($gotsym,$pclabel) = @_;
    		eval q(. &align 2; $gotsym: . &word  &_C_LABEL( &_GLOBAL_OFFSET_TABLE_) - ($pclabel+8));
	    }' unless defined(&GOT_INITSYM);
	}
	if(defined(&__STDC__)) {
	    eval 'sub PIC_SYM {
	        my($x,$y) = @_;
    		eval q($x  (  $y  ));
	    }' unless defined(&PIC_SYM);
	} else {
	    eval 'sub PIC_SYM {
	        my($x,$y) = @_;
    		eval q($x ( $y ));
	    }' unless defined(&PIC_SYM);
	}
    } else {
	eval 'sub PLT_SYM {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PLT_SYM);
	eval 'sub GOT_SYM {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&GOT_SYM);
	eval 'sub GOT_GET {
	    my($x,$got,$sym) = @_;
    	    eval q( &ldr $x, $sym;);
	}' unless defined(&GOT_GET);
	eval 'sub GOT_INIT {
	    my($got,$gotsym,$pclabel) = @_;
    	    eval q();
	}' unless defined(&GOT_INIT);
	eval 'sub GOT_INITSYM {
	    my($gotsym,$pclabel) = @_;
    	    eval q();
	}' unless defined(&GOT_INITSYM);
	eval 'sub PIC_SYM {
	    my($x,$y) = @_;
    	    eval q($x);
	}' unless defined(&PIC_SYM);
    }
    undef(&__FBSDID) if defined(&__FBSDID);
    if(!defined(&lint)  && !defined(&STRIP_FBSDID)) {
	eval 'sub __FBSDID {
	    my($s) = @_;
    	    eval q(. &ident $s);
	}' unless defined(&__FBSDID);
    } else {
	eval 'sub __FBSDID {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&__FBSDID);
    }
    eval 'sub WEAK_ALIAS {
        my($alias,$sym) = @_;
	    eval q(. &weak $alias; $alias = $sym);
    }' unless defined(&WEAK_ALIAS);
    if(defined(&__STDC__)) {
	eval 'sub WARN_REFERENCES {
	    my($sym,$msg) = @_;
    	    eval q(. &stabs $msg  ,30,0,0,0; . &stabs  &__STRING( &_C_LABEL($sym))  ,1,0,0,0);
	}' unless defined(&WARN_REFERENCES);
    } else {
	eval 'sub WARN_REFERENCES {
	    my($sym,$msg) = @_;
    	    eval q(. &stabs $msg,30,0,0,0; . &stabs  &__STRING($sym),1,0,0,0);
	}' unless defined(&WARN_REFERENCES);
    }
    if(defined (&__ARM_ARCH_7__) || defined (&__ARM_ARCH_7A__)) {
	eval 'sub _ARM_ARCH_7 () {1;}' unless defined(&_ARM_ARCH_7);
	eval 'sub _HAVE_ARMv7_INSTRUCTIONS () {1;}' unless defined(&_HAVE_ARMv7_INSTRUCTIONS);
    }
    if(defined (&_HAVE_ARMv7_INSTRUCTIONS) || defined (&__ARM_ARCH_6__) || defined (&__ARM_ARCH_6J__) || defined (&__ARM_ARCH_6K__) || defined (&__ARM_ARCH_6KZ__) || defined (&__ARM_ARCH_6Z__) || defined (&__ARM_ARCH_6ZK__)) {
	eval 'sub _ARM_ARCH_6 () {1;}' unless defined(&_ARM_ARCH_6);
	eval 'sub _HAVE_ARMv6_INSTRUCTIONS () {1;}' unless defined(&_HAVE_ARMv6_INSTRUCTIONS);
    }
    if(defined (&_HAVE_ARMv6_INSTRUCTIONS) || defined (&__ARM_ARCH_5TE__) || defined (&__ARM_ARCH_5TEJ__) || defined (&__ARM_ARCH_5E__)) {
	eval 'sub _ARM_ARCH_5E () {1;}' unless defined(&_ARM_ARCH_5E);
	eval 'sub _HAVE_ARMv5E_INSTRUCTIONS () {1;}' unless defined(&_HAVE_ARMv5E_INSTRUCTIONS);
    }
    if(defined (&_HAVE_ARMv5E_INSTRUCTIONS) || defined (&__ARM_ARCH_5__) || defined (&__ARM_ARCH_5T__)) {
	eval 'sub _ARM_ARCH_5 () {1;}' unless defined(&_ARM_ARCH_5);
	eval 'sub _HAVE_ARMv5_INSTRUCTIONS () {1;}' unless defined(&_HAVE_ARMv5_INSTRUCTIONS);
    }
    if(defined (&_HAVE_ARMv5_INSTRUCTIONS) || defined (&__ARM_ARCH_4T__)) {
	eval 'sub _ARM_ARCH_4T () {1;}' unless defined(&_ARM_ARCH_4T);
	eval 'sub _HAVE_ARMv4T_INSTRUCTIONS () {1;}' unless defined(&_HAVE_ARMv4T_INSTRUCTIONS);
    }
    eval 'sub _HAVE_ARMv4_INSTRUCTIONS () {1;}' unless defined(&_HAVE_ARMv4_INSTRUCTIONS);
    if(defined (&_HAVE_ARMv4T_INSTRUCTIONS)) {
	eval 'sub RET () { &bx  &lr;}' unless defined(&RET);
	eval 'sub RETeq () { &bxeq  &lr;}' unless defined(&RETeq);
	eval 'sub RETne () { &bxne  &lr;}' unless defined(&RETne);
	eval 'sub RETc {
	    my($c) = @_;
    	    eval q( &bx$c  &lr);
	}' unless defined(&RETc);
    } else {
	eval 'sub RET () { &mov  &pc,  &lr;}' unless defined(&RET);
	eval 'sub RETeq () { &moveq  &pc,  &lr;}' unless defined(&RETeq);
	eval 'sub RETne () { &movne  &pc,  &lr;}' unless defined(&RETne);
	eval 'sub RETc {
	    my($c) = @_;
    	    eval q( &mov$c  &pc,  &lr);
	}' unless defined(&RETc);
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7) {
	eval 'sub ISB () { &isb;}' unless defined(&ISB);
	eval 'sub DSB () { &dsb;}' unless defined(&DSB);
	eval 'sub DMB () { &dmb;}' unless defined(&DMB);
	eval 'sub WFI () { &wfi;}' unless defined(&WFI);
	if(defined(&__ARM_ARCH_7VE__) || defined(&__clang__)) {
	    eval 'sub MSR_ELR_HYP {
	        my($regnum) = @_;
    		eval q( &msr  &elr_hyp,  &lr);
	    }' unless defined(&MSR_ELR_HYP);
	    eval 'sub ERET () { &eret;}' unless defined(&ERET);
	} else {
	    eval 'sub MSR_ELR_HYP {
	        my($regnum) = @_;
    		eval q(. &word (0xe12ef300 | $regnum));
	    }' unless defined(&MSR_ELR_HYP);
	    eval 'sub ERET () {. &word 0xe160006e;}' unless defined(&ERET);
	}
    }
 elsif((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) == 6) {
	eval 'sub ISB () { &mcr  &CP15_CP15ISB;}' unless defined(&ISB);
	eval 'sub DSB () { &mcr  &CP15_CP15DSB;}' unless defined(&DSB);
	eval 'sub DMB () { &mcr  &CP15_CP15DMB;}' unless defined(&DMB);
	eval 'sub WFI () { &mcr  &CP15_CP15WFI;}' unless defined(&WFI);
    } else {
	eval 'sub ISB () { &mcr  &CP15_CP15ISB;}' unless defined(&ISB);
	eval 'sub DSB () { &mcr  &CP15_CP15DSB;}' unless defined(&DSB);
	eval 'sub DMB () { &mcr  &CP15_CP15DSB;}' unless defined(&DMB);
    }
}
1;
