require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ATOMIC_V4_H_)) {
    eval 'sub _MACHINE_ATOMIC_V4_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_V4_H_);
    unless(defined(&_MACHINE_ATOMIC_H_)) {
	die("Do\ not\ include\ this\ file\ directly\,\ use\ \<machine\/atomic\.h\>");
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) <= 5) {
	eval 'sub isb () {
	    eval q( &__asm  &__volatile(\\"mcr p15, 0, %0, c7, c5, 4\\" : : \\"r\\" (0) : \\"memory\\"));
	}' unless defined(&isb);
	eval 'sub dsb () {
	    eval q( &__asm  &__volatile(\\"mcr p15, 0, %0, c7, c10, 4\\" : : \\"r\\" (0) : \\"memory\\"));
	}' unless defined(&dsb);
	eval 'sub dmb () {
	    eval q( &dsb());
	}' unless defined(&dmb);
    } else {
	die("Only\ use\ this\ file\ with\ ARMv5\ and\ earlier");
    }
    eval 'sub mb () {
        eval q( &dmb());
    }' unless defined(&mb);
    eval 'sub wmb () {
        eval q( &dmb());
    }' unless defined(&wmb);
    eval 'sub rmb () {
        eval q( &dmb());
    }' unless defined(&rmb);
    eval 'sub __with_interrupts_disabled {
        my($expr) = @_;
	    eval q( &do { \'u_int\'  &cpsr_save,  &tmp;  &__asm  &__volatile( \\"mrs  %0, cpsr;\\" \\"orr  %1, %0, %2;\\" \\"msr  cpsr_fsxc, %1;\\" : \\"=r\\" ( &cpsr_save), \\"=r\\" ( &tmp) : \\"I\\" ( &PSR_I |  &PSR_F) : \\"cc\\" ); ($expr);  &__asm  &__volatile( \\"msr  cpsr_fsxc, %0\\" : : \\"r\\" ( &cpsr_save) : \\"cc\\" ); }  &while(0));
    }' unless defined(&__with_interrupts_disabled);
    eval 'sub __swp {
        my($val,$ptr) = @_;
	    eval q({  &__asm  &__volatile(\\"swp	%0, %2, [%3]\\" : \\"=&r\\" ($val), \\"=m\\" (*$ptr) : \\"r\\" ($val), \\"r\\" ($ptr), \\"m\\" (*$ptr) : \\"memory\\"); ($val); });
    }' unless defined(&__swp);
    if(defined(&_KERNEL)) {
	eval 'sub ARM_HAVE_ATOMIC64 () {1;}' unless defined(&ARM_HAVE_ATOMIC64);
	eval 'sub atomic_add_32 {
	    my($p,$val) = @_;
    	    eval q({  &__with_interrupts_disabled(*$p += $val); });
	}' unless defined(&atomic_add_32);
	eval 'sub atomic_add_64 {
	    my($p,$val) = @_;
    	    eval q({  &__with_interrupts_disabled(*$p += $val); });
	}' unless defined(&atomic_add_64);
	eval 'sub atomic_clear_32 {
	    my($address,$clearmask) = @_;
    	    eval q({  &__with_interrupts_disabled(*$address &= ~$clearmask); });
	}' unless defined(&atomic_clear_32);
	eval 'sub atomic_clear_64 {
	    my($address,$clearmask) = @_;
    	    eval q({  &__with_interrupts_disabled(*$address &= ~$clearmask); });
	}' unless defined(&atomic_clear_64);
	eval 'sub atomic_fcmpset_8 {
	    my($p,$cmpval,$newval) = @_;
    	    eval q({ \'int\'  &ret;  &__with_interrupts_disabled( {  &ret = *$p;  &if (*$p == *$cmpval) { *$p = $newval;  &ret = 1; }  &else { *$cmpval = *$p;  &ret = 0; } }); ( &ret); });
	}' unless defined(&atomic_fcmpset_8);
	eval 'sub atomic_fcmpset_16 {
	    my($p,$cmpval,$newval) = @_;
    	    eval q({ \'int\'  &ret;  &__with_interrupts_disabled( {  &ret = *$p;  &if (*$p == *$cmpval) { *$p = $newval;  &ret = 1; }  &else { *$cmpval = *$p;  &ret = 0; } }); ( &ret); });
	}' unless defined(&atomic_fcmpset_16);
	eval 'sub atomic_fcmpset_32 {
	    my($p,$cmpval,$newval) = @_;
    	    eval q({ \'int\'  &ret;  &__with_interrupts_disabled( {  &ret = *$p;  &if (*$p == *$cmpval) { *$p = $newval;  &ret = 1; }  &else { *$cmpval = *$p;  &ret = 0; } }); ( &ret); });
	}' unless defined(&atomic_fcmpset_32);
	eval 'sub atomic_fcmpset_64 {
	    my($p,$cmpval,$newval) = @_;
    	    eval q({ \'int\'  &ret;  &__with_interrupts_disabled( {  &if (*$p == *$cmpval) { *$p = $newval;  &ret = 1; }  &else { *$cmpval = *$p;  &ret = 0; } }); ( &ret); });
	}' unless defined(&atomic_fcmpset_64);
	eval 'sub atomic_cmpset_8 {
	    my($p,$cmpval,$newval) = @_;
    	    eval q({ \'int\'  &ret;  &__with_interrupts_disabled( {  &if (*$p == $cmpval) { *$p = $newval;  &ret = 1; }  &else {  &ret = 0; } }); ( &ret); });
	}' unless defined(&atomic_cmpset_8);
	eval 'sub atomic_cmpset_16 {
	    my($p,$cmpval,$newval) = @_;
    	    eval q({ \'int\'  &ret;  &__with_interrupts_disabled( {  &if (*$p == $cmpval) { *$p = $newval;  &ret = 1; }  &else {  &ret = 0; } }); ( &ret); });
	}' unless defined(&atomic_cmpset_16);
	eval 'sub atomic_cmpset_32 {
	    my($p,$cmpval,$newval) = @_;
    	    eval q({ \'int\'  &ret;  &__with_interrupts_disabled( {  &if (*$p == $cmpval) { *$p = $newval;  &ret = 1; }  &else {  &ret = 0; } }); ( &ret); });
	}' unless defined(&atomic_cmpset_32);
	eval 'sub atomic_cmpset_64 {
	    my($p,$cmpval,$newval) = @_;
    	    eval q({ \'int\'  &ret;  &__with_interrupts_disabled( {  &if (*$p == $cmpval) { *$p = $newval;  &ret = 1; }  &else {  &ret = 0; } }); ( &ret); });
	}' unless defined(&atomic_cmpset_64);
	eval 'sub atomic_fetchadd_32 {
	    my($p,$v) = @_;
    	    eval q({  &uint32_t  &value;  &__with_interrupts_disabled( {  &value = *$p; *$p += $v; }); ( &value); });
	}' unless defined(&atomic_fetchadd_32);
	eval 'sub atomic_fetchadd_64 {
	    my($p,$v) = @_;
    	    eval q({  &uint64_t  &value;  &__with_interrupts_disabled( {  &value = *$p; *$p += $v; }); ( &value); });
	}' unless defined(&atomic_fetchadd_64);
	eval 'sub atomic_load_64 {
	    my($p) = @_;
    	    eval q({  &uint64_t  &value;  &__with_interrupts_disabled( &value = *$p); ( &value); });
	}' unless defined(&atomic_load_64);
	eval 'sub atomic_set_32 {
	    my($address,$setmask) = @_;
    	    eval q({  &__with_interrupts_disabled(*$address |= $setmask); });
	}' unless defined(&atomic_set_32);
	eval 'sub atomic_set_64 {
	    my($address,$setmask) = @_;
    	    eval q({  &__with_interrupts_disabled(*$address |= $setmask); });
	}' unless defined(&atomic_set_64);
	eval 'sub atomic_store_64 {
	    my($p,$value) = @_;
    	    eval q({  &__with_interrupts_disabled(*$p = $value); });
	}' unless defined(&atomic_store_64);
	eval 'sub atomic_subtract_32 {
	    my($p,$val) = @_;
    	    eval q({  &__with_interrupts_disabled(*$p -= $val); });
	}' unless defined(&atomic_subtract_32);
	eval 'sub atomic_subtract_64 {
	    my($p,$val) = @_;
    	    eval q({  &__with_interrupts_disabled(*$p -= $val); });
	}' unless defined(&atomic_subtract_64);
	eval 'sub atomic_swap_64 {
	    my($p,$v) = @_;
    	    eval q({  &uint64_t  &value;  &__with_interrupts_disabled( {  &value = *$p; *$p = $v; }); ( &value); });
	}' unless defined(&atomic_swap_64);
    } else {
	eval 'sub atomic_add_32 {
	    my($p,$val) = @_;
    	    eval q({ \'int\'  &start,  &ras_start =  &ARM_RAS_START;  &__asm  &__volatile(\\"1:\\\\n\\" \\"adr	%1, 1b\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"adr	%1, 2f\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" \\"ldr	%1, [%2]\\\\n\\" \\"add	%1, %1, %3\\\\n\\" \\"str	%1, [%2]\\\\n\\" \\"2:\\\\n\\" \\"mov	%1, #0\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"mov	%1, #0xffffffff\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" : \\"+r\\" ( &ras_start), \\"=r\\" ( &start), \\"+r\\" ($p), \\"+r\\" ($val) : : \\"memory\\"); });
	}' unless defined(&atomic_add_32);
	eval 'sub atomic_clear_32 {
	    my($address,$clearmask) = @_;
    	    eval q({ \'int\'  &start,  &ras_start =  &ARM_RAS_START;  &__asm  &__volatile(\\"1:\\\\n\\" \\"adr	%1, 1b\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"adr	%1, 2f\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" \\"ldr	%1, [%2]\\\\n\\" \\"bic	%1, %1, %3\\\\n\\" \\"str	%1, [%2]\\\\n\\" \\"2:\\\\n\\" \\"mov	%1, #0\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"mov	%1, #0xffffffff\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" : \\"+r\\" ( &ras_start), \\"=r\\" ( &start), \\"+r\\" ($address), \\"+r\\" ($clearmask) : : \\"memory\\"); });
	}' unless defined(&atomic_clear_32);
	eval 'sub atomic_cmpset_32 {
	    my($p,$cmpval,$newval) = @_;
    	    eval q({ \'int\'  &done,  &ras_start =  &ARM_RAS_START;  &__asm  &__volatile(\\"1:\\\\n\\" \\"adr	%1, 1b\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"adr	%1, 2f\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" \\"ldr	%1, [%2]\\\\n\\" \\"cmp	%1, %3\\\\n\\" \\"streq	%4, [%2]\\\\n\\" \\"2:\\\\n\\" \\"mov	%1, #0\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"mov	%1, #0xffffffff\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" \\"moveq	%1, #1\\\\n\\" \\"movne	%1, #0\\\\n\\" : \\"+r\\" ( &ras_start), \\"=r\\" ( &done) ,\\"+r\\" ($p), \\"+r\\" ($cmpval), \\"+r\\" ($newval) : : \\"cc\\", \\"memory\\"); ( &done); });
	}' unless defined(&atomic_cmpset_32);
	eval 'sub atomic_fcmpset_32 {
	    my($p,$cmpval,$newval) = @_;
    	    eval q({ \'int\'  &done,  &oldval,  &ras_start =  &ARM_RAS_START;  &__asm  &__volatile(\\"1:\\\\n\\" \\"adr	%1, 1b\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"adr	%1, 2f\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" \\"ldr	%1, [%2]\\\\n\\" \\"ldr	%5, [%3]\\\\n\\" \\"cmp	%1, %5\\\\n\\" \\"streq	%4, [%2]\\\\n\\" \\"2:\\\\n\\" \\"mov	%5, #0\\\\n\\" \\"str	%5, [%0]\\\\n\\" \\"mov	%5, #0xffffffff\\\\n\\" \\"str	%5, [%0, #4]\\\\n\\" \\"strne	%1, [%3]\\\\n\\" \\"moveq	%1, #1\\\\n\\" \\"movne	%1, #0\\\\n\\" : \\"+r\\" ( &ras_start), \\"=r\\" ( &done) ,\\"+r\\" ($p) , \\"+r\\" ($cmpval), \\"+r\\" ($newval), \\"+r\\" ( &oldval) : : \\"cc\\", \\"memory\\"); ( &done); });
	}' unless defined(&atomic_fcmpset_32);
	eval 'sub atomic_fetchadd_32 {
	    my($p,$v) = @_;
    	    eval q({  &uint32_t  &start,  &tmp,  &ras_start =  &ARM_RAS_START;  &__asm  &__volatile(\\"1:\\\\n\\" \\"adr	%1, 1b\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"adr	%1, 2f\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" \\"ldr	%1, [%3]\\\\n\\" \\"mov	%2, %1\\\\n\\" \\"add	%2, %2, %4\\\\n\\" \\"str	%2, [%3]\\\\n\\" \\"2:\\\\n\\" \\"mov	%2, #0\\\\n\\" \\"str	%2, [%0]\\\\n\\" \\"mov	%2, #0xffffffff\\\\n\\" \\"str	%2, [%0, #4]\\\\n\\" : \\"+r\\" ( &ras_start), \\"=r\\" ( &start), \\"=r\\" ( &tmp), \\"+r\\" ($p), \\"+r\\" ($v) : : \\"memory\\"); ( &start); });
	}' unless defined(&atomic_fetchadd_32);
	eval 'sub atomic_set_32 {
	    my($address,$setmask) = @_;
    	    eval q({ \'int\'  &start,  &ras_start =  &ARM_RAS_START;  &__asm  &__volatile(\\"1:\\\\n\\" \\"adr	%1, 1b\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"adr	%1, 2f\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" \\"ldr	%1, [%2]\\\\n\\" \\"orr	%1, %1, %3\\\\n\\" \\"str	%1, [%2]\\\\n\\" \\"2:\\\\n\\" \\"mov	%1, #0\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"mov	%1, #0xffffffff\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" : \\"+r\\" ( &ras_start), \\"=r\\" ( &start), \\"+r\\" ($address), \\"+r\\" ($setmask) : : \\"memory\\"); });
	}' unless defined(&atomic_set_32);
	eval 'sub atomic_subtract_32 {
	    my($p,$val) = @_;
    	    eval q({ \'int\'  &start,  &ras_start =  &ARM_RAS_START;  &__asm  &__volatile(\\"1:\\\\n\\" \\"adr	%1, 1b\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"adr	%1, 2f\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" \\"ldr	%1, [%2]\\\\n\\" \\"sub	%1, %1, %3\\\\n\\" \\"str	%1, [%2]\\\\n\\" \\"2:\\\\n\\" \\"mov	%1, #0\\\\n\\" \\"str	%1, [%0]\\\\n\\" \\"mov	%1, #0xffffffff\\\\n\\" \\"str	%1, [%0, #4]\\\\n\\" : \\"+r\\" ( &ras_start), \\"=r\\" ( &start), \\"+r\\" ($p), \\"+r\\" ($val) : : \\"memory\\"); });
	}' unless defined(&atomic_subtract_32);
    }
    eval 'sub atomic_readandclear_32 {
        my($p) = @_;
	    eval q({ ( &__swp(0, $p)); });
    }' unless defined(&atomic_readandclear_32);
    eval 'sub atomic_swap_32 {
        my($p,$v) = @_;
	    eval q({ ( &__swp($v, $p)); });
    }' unless defined(&atomic_swap_32);
    eval 'sub atomic_fcmpset_rel_32 () { &atomic_fcmpset_32;}' unless defined(&atomic_fcmpset_rel_32);
    eval 'sub atomic_fcmpset_acq_32 () { &atomic_fcmpset_32;}' unless defined(&atomic_fcmpset_acq_32);
    if(defined(&_KERNEL)) {
	eval 'sub atomic_fcmpset_rel_8 () { &atomic_fcmpset_8;}' unless defined(&atomic_fcmpset_rel_8);
	eval 'sub atomic_fcmpset_acq_8 () { &atomic_fcmpset_8;}' unless defined(&atomic_fcmpset_acq_8);
	eval 'sub atomic_fcmpset_rel_16 () { &atomic_fcmpset_16;}' unless defined(&atomic_fcmpset_rel_16);
	eval 'sub atomic_fcmpset_acq_16 () { &atomic_fcmpset_16;}' unless defined(&atomic_fcmpset_acq_16);
	eval 'sub atomic_fcmpset_rel_64 () { &atomic_fcmpset_64;}' unless defined(&atomic_fcmpset_rel_64);
	eval 'sub atomic_fcmpset_acq_64 () { &atomic_fcmpset_64;}' unless defined(&atomic_fcmpset_acq_64);
    }
    eval 'sub atomic_fcmpset_acq_long () {\'atomic_fcmpset_long\';}' unless defined(&atomic_fcmpset_acq_long);
    eval 'sub atomic_fcmpset_rel_long () {\'atomic_fcmpset_long\';}' unless defined(&atomic_fcmpset_rel_long);
    eval 'sub atomic_cmpset_rel_32 () { &atomic_cmpset_32;}' unless defined(&atomic_cmpset_rel_32);
    eval 'sub atomic_cmpset_acq_32 () { &atomic_cmpset_32;}' unless defined(&atomic_cmpset_acq_32);
    if(defined(&_KERNEL)) {
	eval 'sub atomic_cmpset_rel_8 () { &atomic_cmpset_8;}' unless defined(&atomic_cmpset_rel_8);
	eval 'sub atomic_cmpset_acq_8 () { &atomic_cmpset_8;}' unless defined(&atomic_cmpset_acq_8);
	eval 'sub atomic_cmpset_rel_16 () { &atomic_cmpset_16;}' unless defined(&atomic_cmpset_rel_16);
	eval 'sub atomic_cmpset_acq_16 () { &atomic_cmpset_16;}' unless defined(&atomic_cmpset_acq_16);
	eval 'sub atomic_cmpset_rel_64 () { &atomic_cmpset_64;}' unless defined(&atomic_cmpset_rel_64);
	eval 'sub atomic_cmpset_acq_64 () { &atomic_cmpset_64;}' unless defined(&atomic_cmpset_acq_64);
    }
    eval 'sub atomic_set_rel_32 () { &atomic_set_32;}' unless defined(&atomic_set_rel_32);
    eval 'sub atomic_set_acq_32 () { &atomic_set_32;}' unless defined(&atomic_set_acq_32);
    eval 'sub atomic_clear_rel_32 () { &atomic_clear_32;}' unless defined(&atomic_clear_rel_32);
    eval 'sub atomic_clear_acq_32 () { &atomic_clear_32;}' unless defined(&atomic_clear_acq_32);
    eval 'sub atomic_add_rel_32 () { &atomic_add_32;}' unless defined(&atomic_add_rel_32);
    eval 'sub atomic_add_acq_32 () { &atomic_add_32;}' unless defined(&atomic_add_acq_32);
    eval 'sub atomic_subtract_rel_32 () { &atomic_subtract_32;}' unless defined(&atomic_subtract_rel_32);
    eval 'sub atomic_subtract_acq_32 () { &atomic_subtract_32;}' unless defined(&atomic_subtract_acq_32);
    eval 'sub atomic_store_rel_32 () { &atomic_store_32;}' unless defined(&atomic_store_rel_32);
    eval 'sub atomic_store_rel_long () {\'atomic_store_long\';}' unless defined(&atomic_store_rel_long);
    eval 'sub atomic_store_rel_64 () { &atomic_store_64;}' unless defined(&atomic_store_rel_64);
    eval 'sub atomic_load_acq_32 () { &atomic_load_32;}' unless defined(&atomic_load_acq_32);
    eval 'sub atomic_load_acq_long () {\'atomic_load_long\';}' unless defined(&atomic_load_acq_long);
    eval 'sub atomic_add_acq_long () {\'atomic_add_long\';}' unless defined(&atomic_add_acq_long);
    eval 'sub atomic_add_rel_long () {\'atomic_add_long\';}' unless defined(&atomic_add_rel_long);
    eval 'sub atomic_subtract_acq_long () {\'atomic_subtract_long\';}' unless defined(&atomic_subtract_acq_long);
    eval 'sub atomic_subtract_rel_long () {\'atomic_subtract_long\';}' unless defined(&atomic_subtract_rel_long);
    eval 'sub atomic_clear_acq_long () {\'atomic_clear_long\';}' unless defined(&atomic_clear_acq_long);
    eval 'sub atomic_clear_rel_long () {\'atomic_clear_long\';}' unless defined(&atomic_clear_rel_long);
    eval 'sub atomic_set_acq_long () {\'atomic_set_long\';}' unless defined(&atomic_set_acq_long);
    eval 'sub atomic_set_rel_long () {\'atomic_set_long\';}' unless defined(&atomic_set_rel_long);
    eval 'sub atomic_cmpset_acq_long () {\'atomic_cmpset_long\';}' unless defined(&atomic_cmpset_acq_long);
    eval 'sub atomic_cmpset_rel_long () {\'atomic_cmpset_long\';}' unless defined(&atomic_cmpset_rel_long);
    eval 'sub atomic_load_acq_long () {\'atomic_load_long\';}' unless defined(&atomic_load_acq_long);
    undef(&__with_interrupts_disabled) if defined(&__with_interrupts_disabled);
    eval 'sub atomic_add_long {
        my($p,$v) = @_;
	    eval q({  &atomic_add_32(( &volatile  &uint32_t *)$p, $v); });
    }' unless defined(&atomic_add_long);
    eval 'sub atomic_clear_long {
        my($p,$v) = @_;
	    eval q({  &atomic_clear_32(( &volatile  &uint32_t *)$p, $v); });
    }' unless defined(&atomic_clear_long);
    eval 'sub atomic_cmpset_long {
        my($dst,$old,$newe) = @_;
	    eval q({ ( &atomic_cmpset_32(( &volatile  &uint32_t *)$dst, $old, $newe)); });
    }' unless defined(&atomic_cmpset_long);
    eval 'sub atomic_fcmpset_long {
        my($dst,$old,$newe) = @_;
	    eval q({ ( &atomic_fcmpset_32(( &volatile  &uint32_t *)$dst, ( &uint32_t *)$old, $newe)); });
    }' unless defined(&atomic_fcmpset_long);
    eval 'sub atomic_fetchadd_long {
        my($p,$v) = @_;
	    eval q({ ( &atomic_fetchadd_32(( &volatile  &uint32_t *)$p, $v)); });
    }' unless defined(&atomic_fetchadd_long);
    eval 'sub atomic_readandclear_long {
        my($p) = @_;
	    eval q({  &atomic_readandclear_32(( &volatile  &uint32_t *)$p); });
    }' unless defined(&atomic_readandclear_long);
    eval 'sub atomic_set_long {
        my($p,$v) = @_;
	    eval q({  &atomic_set_32(( &volatile  &uint32_t *)$p, $v); });
    }' unless defined(&atomic_set_long);
    eval 'sub atomic_subtract_long {
        my($p,$v) = @_;
	    eval q({  &atomic_subtract_32(( &volatile  &uint32_t *)$p, $v); });
    }' unless defined(&atomic_subtract_long);
    eval 'sub atomic_thread_fence_rel {
        my($void) = @_;
	    eval q({  &__compiler_membar(); });
    }' unless defined(&atomic_thread_fence_rel);
    eval 'sub atomic_thread_fence_acq_rel {
        my($void) = @_;
	    eval q({  &__compiler_membar(); });
    }' unless defined(&atomic_thread_fence_acq_rel);
    eval 'sub atomic_thread_fence_seq_cst {
        my($void) = @_;
	    eval q({  &__compiler_membar(); });
    }' unless defined(&atomic_thread_fence_seq_cst);
}
1;
