require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ATOMIC_V6_H_)) {
    eval 'sub _MACHINE_ATOMIC_V6_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_V6_H_);
    unless(defined(&_MACHINE_ATOMIC_H_)) {
	die("Do\ not\ include\ this\ file\ directly\,\ use\ \<machine\/atomic\.h\>");
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7) {
	eval 'sub isb () {
	    eval q( &__asm  &__volatile(\\"isb\\" : : : \\"memory\\"));
	}' unless defined(&isb);
	eval 'sub dsb () {
	    eval q( &__asm  &__volatile(\\"dsb\\" : : : \\"memory\\"));
	}' unless defined(&dsb);
	eval 'sub dmb () {
	    eval q( &__asm  &__volatile(\\"dmb\\" : : : \\"memory\\"));
	}' unless defined(&dmb);
    }
 elsif((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	eval 'sub isb () {
	    eval q( &__asm  &__volatile(\\"mcr p15, 0, %0, c7, c5, 4\\" : : \\"r\\" (0) : \\"memory\\"));
	}' unless defined(&isb);
	eval 'sub dsb () {
	    eval q( &__asm  &__volatile(\\"mcr p15, 0, %0, c7, c10, 4\\" : : \\"r\\" (0) : \\"memory\\"));
	}' unless defined(&dsb);
	eval 'sub dmb () {
	    eval q( &__asm  &__volatile(\\"mcr p15, 0, %0, c7, c10, 5\\" : : \\"r\\" (0) : \\"memory\\"));
	}' unless defined(&dmb);
    } else {
	die("Only\ use\ this\ file\ with\ ARMv6\ and\ later");
    }
    eval 'sub mb () {
        eval q( &dmb());
    }' unless defined(&mb);
    eval 'sub wmb () {
        eval q( &dmb());
    }' unless defined(&wmb);
    eval 'sub rmb () {
        eval q( &dmb());
    }' unless defined(&rmb);
    eval 'sub ARM_HAVE_ATOMIC64 () {1;}' unless defined(&ARM_HAVE_ATOMIC64);
    eval 'sub ATOMIC_ACQ_REL_LONG {
        my($NAME) = @_;
	    eval q( &static  &__inline  &void  &atomic_$NAME &_acq_long( &__volatile \'u_long\' * &p, \'u_long v\') {  &atomic_$NAME &_long( &p,  &v);  &dmb(); }  &static  &__inline  &void  &atomic_$NAME &_rel_long( &__volatile \'u_long\' * &p, \'u_long v\') {  &dmb();  &atomic_$NAME &_long( &p,  &v); });
    }' unless defined(&ATOMIC_ACQ_REL_LONG);
    eval 'sub ATOMIC_ACQ_REL {
        my($NAME, $WIDTH) = @_;
	    eval q( &static  &__inline  &void  &atomic_$NAME &_acq_$WIDTH( &__volatile \'uint\'$WIDTH &_t * &p, \'uint\'$WIDTH &_t  &v){  &atomic_$NAME &_$WIDTH( &p,  &v);  &dmb(); }  &static  &__inline  &void  &atomic_$NAME &_rel_$WIDTH( &__volatile \'uint\'$WIDTH &_t * &p, \'uint\'$WIDTH &_t  &v){  &dmb();  &atomic_$NAME &_$WIDTH( &p,  &v); });
    }' unless defined(&ATOMIC_ACQ_REL);
    eval 'sub atomic_add_32 {
        my($p,$val) = @_;
	    eval q({  &uint32_t  &tmp = 0,  &tmp2 = 0;  &__asm  &__volatile( \\"1: ldrex	%0, [%2]	\\\\n\\" \\"   add	%0, %0, %3	\\\\n\\" \\"   strex	%1, %0, [%2]	\\\\n\\" \\"   cmp	%1, #0		\\\\n\\" \\"   it	ne		\\\\n\\" \\"   bne	1b		\\\\n\\" : \\"=&r\\" ( &tmp), \\"+r\\" ( &tmp2) ,\\"+r\\" ($p), \\"+r\\" ($val) : : \\"cc\\", \\"memory\\"); });
    }' unless defined(&atomic_add_32);
    eval 'sub atomic_add_64 {
        my($p,$val) = @_;
	    eval q({  &uint64_t  &tmp;  &uint32_t  &exflag;  &__asm  &__volatile( \\"1:							\\\\n\\" \\"   ldrexd	%Q[tmp], %R[tmp], [%[ptr]]		\\\\n\\" \\"   adds	%Q[tmp], %Q[val]			\\\\n\\" \\"   adc	%R[tmp], %R[tmp], %R[val]		\\\\n\\" \\"   strexd	%[exf], %Q[tmp], %R[tmp], [%[ptr]]	\\\\n\\" \\"   teq	%[exf], #0				\\\\n\\" \\"   it	ne					\\\\n\\" \\"   bne	1b					\\\\n\\" : [ &exf] \\"=&r\\" ( &exflag), [ &tmp] \\"=&r\\" ( &tmp) : [ &ptr] \\"r\\" ($p), [$val] \\"r\\" ($val) : \\"cc\\", \\"memory\\"); });
    }' unless defined(&atomic_add_64);
    eval 'sub atomic_add_long {
        my($p,$val) = @_;
	    eval q({  &atomic_add_32(( &volatile  &uint32_t *)$p, $val); });
    }' unless defined(&atomic_add_long);
    eval 'sub atomic_clear_32 {
        my($address,$setmask) = @_;
	    eval q({  &uint32_t  &tmp = 0,  &tmp2 = 0;  &__asm  &__volatile( \\"1: ldrex	%0, [%2]	\\\\n\\" \\"   bic	%0, %0, %3	\\\\n\\" \\"   strex	%1, %0, [%2]	\\\\n\\" \\"   cmp	%1, #0		\\\\n\\" \\"   it	ne		\\\\n\\" \\"   bne	1b		\\\\n\\" : \\"=&r\\" ( &tmp), \\"+r\\" ( &tmp2), \\"+r\\" ($address), \\"+r\\" ($setmask) : : \\"cc\\", \\"memory\\"); });
    }' unless defined(&atomic_clear_32);
    eval 'sub atomic_clear_64 {
        my($p,$val) = @_;
	    eval q({  &uint64_t  &tmp;  &uint32_t  &exflag;  &__asm  &__volatile( \\"1:							\\\\n\\" \\"   ldrexd	%Q[tmp], %R[tmp], [%[ptr]]		\\\\n\\" \\"   bic	%Q[tmp], %Q[val]			\\\\n\\" \\"   bic	%R[tmp], %R[val]			\\\\n\\" \\"   strexd	%[exf], %Q[tmp], %R[tmp], [%[ptr]]	\\\\n\\" \\"   teq	%[exf], #0				\\\\n\\" \\"   it	ne					\\\\n\\" \\"   bne	1b					\\\\n\\" : [ &exf] \\"=&r\\" ( &exflag), [ &tmp] \\"=&r\\" ( &tmp) : [ &ptr] \\"r\\" ($p), [$val] \\"r\\" ($val) : \\"cc\\", \\"memory\\"); });
    }' unless defined(&atomic_clear_64);
    eval 'sub atomic_clear_long {
        my($address,$setmask) = @_;
	    eval q({  &atomic_clear_32(( &volatile  &uint32_t *)$address, $setmask); });
    }' unless defined(&atomic_clear_long);
    eval 'sub ATOMIC_FCMPSET_CODE {
        my($RET, $TYPE, $SUF) = @_;
	    eval q({ $TYPE  &tmp;  &__asm  &__volatile( \\"1: ldrex\\" $SUF \\"   %[tmp], [%[ptr]]	  \\\\n\\" \\"   ldr	    %[ret], [%[oldv]]	 \\\\n\\" \\"   teq	    %[tmp], %[ret]	    \\\\n\\" \\"   ittee	  ne			\\\\n\\" \\"   str\\" $SUF \\"ne   %[tmp], [%[oldv]]	 \\\\n\\" \\"   movne	  %[ret], #0		\\\\n\\" \\"   strex\\" $SUF \\"eq %[ret], %[newv], [%[ptr]] \\\\n\\" \\"   eorseq	 %[ret], #1		\\\\n\\" \\"   beq	    1b			\\\\n\\" : [ &ret] \\"=&r\\" ($RET), [ &tmp] \\"=&r\\" ( &tmp) : [ &ptr] \\"r\\" ( &_ptr), [ &oldv] \\"r\\" ( &_old), [ &newv] \\"r\\" ( &_new) : \\"cc\\", \\"memory\\"); });
    }' unless defined(&ATOMIC_FCMPSET_CODE);
    eval 'sub ATOMIC_FCMPSET_CODE64 {
        my($RET) = @_;
	    eval q({  &uint64_t  &cmp,  &tmp;  &__asm  &__volatile( \\"1: ldrexd   %Q[tmp], %R[tmp], [%[ptr]]	   \\\\n\\" \\"   ldrd     %Q[cmp], %R[cmp], [%[oldv]]	  \\\\n\\" \\"   teq      %Q[tmp], %Q[cmp]		     \\\\n\\" \\"   it       eq				   \\\\n\\" \\"   teqeq    %R[tmp], %R[cmp]		     \\\\n\\" \\"   ittee    ne				   \\\\n\\" \\"   movne    %[ret], #0			   \\\\n\\" \\"   strdne   %[cmp], [%[oldv]]		    \\\\n\\" \\"   strexdeq %[ret], %Q[newv], %R[newv], [%[ptr]] \\\\n\\" \\"   eorseq   %[ret], #1			   \\\\n\\" \\"   beq      1b				   \\\\n\\" : [ &ret] \\"=&r\\" ($RET), [ &cmp] \\"=&r\\" ( &cmp), [ &tmp] \\"=&r\\" ( &tmp) : [ &ptr] \\"r\\" ( &_ptr), [ &oldv] \\"r\\" ( &_old), [ &newv] \\"r\\" ( &_new) : \\"cc\\", \\"memory\\"); });
    }' unless defined(&ATOMIC_FCMPSET_CODE64);
    eval 'sub atomic_fcmpset_8 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_FCMPSET_CODE( &ret,  &uint8_t, \\"b\\"); ( &ret); });
    }' unless defined(&atomic_fcmpset_8);
    eval 'sub atomic_fcmpset_acq_8 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_FCMPSET_CODE( &ret,  &uint8_t, \\"b\\");  &dmb(); ( &ret); });
    }' unless defined(&atomic_fcmpset_acq_8);
    eval 'sub atomic_fcmpset_rel_8 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &dmb();  &ATOMIC_FCMPSET_CODE( &ret,  &uint8_t, \\"b\\"); ( &ret); });
    }' unless defined(&atomic_fcmpset_rel_8);
    eval 'sub atomic_fcmpset_16 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_FCMPSET_CODE( &ret,  &uint16_t, \\"h\\"); ( &ret); });
    }' unless defined(&atomic_fcmpset_16);
    eval 'sub atomic_fcmpset_acq_16 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_FCMPSET_CODE( &ret,  &uint16_t, \\"h\\");  &dmb(); ( &ret); });
    }' unless defined(&atomic_fcmpset_acq_16);
    eval 'sub atomic_fcmpset_rel_16 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &dmb();  &ATOMIC_FCMPSET_CODE( &ret,  &uint16_t, \\"h\\"); ( &ret); });
    }' unless defined(&atomic_fcmpset_rel_16);
    eval 'sub atomic_fcmpset_32 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_FCMPSET_CODE( &ret,  &uint32_t, \\"\\"); ( &ret); });
    }' unless defined(&atomic_fcmpset_32);
    eval 'sub atomic_fcmpset_acq_32 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_FCMPSET_CODE( &ret,  &uint32_t, \\"\\");  &dmb(); ( &ret); });
    }' unless defined(&atomic_fcmpset_acq_32);
    eval 'sub atomic_fcmpset_rel_32 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &dmb();  &ATOMIC_FCMPSET_CODE( &ret,  &uint32_t, \\"\\"); ( &ret); });
    }' unless defined(&atomic_fcmpset_rel_32);
    eval 'sub atomic_fcmpset_long {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_FCMPSET_CODE( &ret, \'long\', \\"\\"); ( &ret); });
    }' unless defined(&atomic_fcmpset_long);
    eval 'sub atomic_fcmpset_acq_long {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_FCMPSET_CODE( &ret, \'long\', \\"\\");  &dmb(); ( &ret); });
    }' unless defined(&atomic_fcmpset_acq_long);
    eval 'sub atomic_fcmpset_rel_long {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &dmb();  &ATOMIC_FCMPSET_CODE( &ret, \'long\', \\"\\"); ( &ret); });
    }' unless defined(&atomic_fcmpset_rel_long);
    eval 'sub atomic_fcmpset_64 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_FCMPSET_CODE64( &ret); ( &ret); });
    }' unless defined(&atomic_fcmpset_64);
    eval 'sub atomic_fcmpset_acq_64 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_FCMPSET_CODE64( &ret);  &dmb(); ( &ret); });
    }' unless defined(&atomic_fcmpset_acq_64);
    eval 'sub atomic_fcmpset_rel_64 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &dmb();  &ATOMIC_FCMPSET_CODE64( &ret); ( &ret); });
    }' unless defined(&atomic_fcmpset_rel_64);
    eval 'sub ATOMIC_CMPSET_CODE {
        my($RET, $SUF) = @_;
	    eval q({  &__asm  &__volatile( \\"1: ldrex\\" $SUF \\"   %[ret], [%[ptr]]	  \\\\n\\" \\"   teq	    %[ret], %[oldv]	   \\\\n\\" \\"   itee	   ne			\\\\n\\" \\"   movne	  %[ret], #0		\\\\n\\" \\"   strex\\" $SUF \\"eq %[ret], %[newv], [%[ptr]] \\\\n\\" \\"   eorseq	 %[ret], #1		\\\\n\\" \\"   beq	    1b			\\\\n\\" : [ &ret] \\"=&r\\" ($RET) : [ &ptr] \\"r\\" ( &_ptr), [ &oldv] \\"r\\" ( &_old), [ &newv] \\"r\\" ( &_new) : \\"cc\\", \\"memory\\"); });
    }' unless defined(&ATOMIC_CMPSET_CODE);
    eval 'sub ATOMIC_CMPSET_CODE64 {
        my($RET) = @_;
	    eval q({  &uint64_t  &tmp;  &__asm  &__volatile( \\"1: ldrexd   %Q[tmp], %R[tmp], [%[ptr]]	   \\\\n\\" \\"   teq      %Q[tmp], %Q[oldv]		    \\\\n\\" \\"   it       eq				   \\\\n\\" \\"   teqeq    %R[tmp], %R[oldv]		    \\\\n\\" \\"   itee     ne				   \\\\n\\" \\"   movne    %[ret], #0			   \\\\n\\" \\"   strexdeq %[ret], %Q[newv], %R[newv], [%[ptr]] \\\\n\\" \\"   eorseq   %[ret], #1			   \\\\n\\" \\"   beq      1b				   \\\\n\\" : [ &ret] \\"=&r\\" ($RET), [ &tmp] \\"=&r\\" ( &tmp) : [ &ptr] \\"r\\" ( &_ptr), [ &oldv] \\"r\\" ( &_old), [ &newv] \\"r\\" ( &_new) : \\"cc\\", \\"memory\\"); });
    }' unless defined(&ATOMIC_CMPSET_CODE64);
    eval 'sub atomic_cmpset_8 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_CMPSET_CODE( &ret, \\"b\\"); ( &ret); });
    }' unless defined(&atomic_cmpset_8);
    eval 'sub atomic_cmpset_acq_8 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_CMPSET_CODE( &ret, \\"b\\");  &dmb(); ( &ret); });
    }' unless defined(&atomic_cmpset_acq_8);
    eval 'sub atomic_cmpset_rel_8 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &dmb();  &ATOMIC_CMPSET_CODE( &ret, \\"b\\"); ( &ret); });
    }' unless defined(&atomic_cmpset_rel_8);
    eval 'sub atomic_cmpset_16 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_CMPSET_CODE( &ret, \\"h\\"); ( &ret); });
    }' unless defined(&atomic_cmpset_16);
    eval 'sub atomic_cmpset_acq_16 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_CMPSET_CODE( &ret, \\"h\\");  &dmb(); ( &ret); });
    }' unless defined(&atomic_cmpset_acq_16);
    eval 'sub atomic_cmpset_rel_16 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &dmb();  &ATOMIC_CMPSET_CODE( &ret, \\"h\\"); ( &ret); });
    }' unless defined(&atomic_cmpset_rel_16);
    eval 'sub atomic_cmpset_32 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_CMPSET_CODE( &ret, \\"\\"); ( &ret); });
    }' unless defined(&atomic_cmpset_32);
    eval 'sub atomic_cmpset_acq_32 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_CMPSET_CODE( &ret, \\"\\");  &dmb(); ( &ret); });
    }' unless defined(&atomic_cmpset_acq_32);
    eval 'sub atomic_cmpset_rel_32 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &dmb();  &ATOMIC_CMPSET_CODE( &ret, \\"\\"); ( &ret); });
    }' unless defined(&atomic_cmpset_rel_32);
    eval 'sub atomic_cmpset_long {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_CMPSET_CODE( &ret, \\"\\"); ( &ret); });
    }' unless defined(&atomic_cmpset_long);
    eval 'sub atomic_cmpset_acq_long {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_CMPSET_CODE( &ret, \\"\\");  &dmb(); ( &ret); });
    }' unless defined(&atomic_cmpset_acq_long);
    eval 'sub atomic_cmpset_rel_long {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &dmb();  &ATOMIC_CMPSET_CODE( &ret, \\"\\"); ( &ret); });
    }' unless defined(&atomic_cmpset_rel_long);
    eval 'sub atomic_cmpset_64 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_CMPSET_CODE64( &ret); ( &ret); });
    }' unless defined(&atomic_cmpset_64);
    eval 'sub atomic_cmpset_acq_64 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &ATOMIC_CMPSET_CODE64( &ret);  &dmb(); ( &ret); });
    }' unless defined(&atomic_cmpset_acq_64);
    eval 'sub atomic_cmpset_rel_64 {
        my($_ptr,$_old,$_new) = @_;
	    eval q({ \'int\'  &ret;  &dmb();  &ATOMIC_CMPSET_CODE64( &ret); ( &ret); });
    }' unless defined(&atomic_cmpset_rel_64);
    eval 'sub atomic_fetchadd_32 {
        my($p,$val) = @_;
	    eval q({  &uint32_t  &tmp = 0,  &tmp2 = 0,  &ret = 0;  &__asm  &__volatile( \\"1: ldrex	%0, [%3]	\\\\n\\" \\"   add	%1, %0, %4	\\\\n\\" \\"   strex	%2, %1, [%3]	\\\\n\\" \\"   cmp	%2, #0		\\\\n\\" \\"   it	ne		\\\\n\\" \\"   bne	1b		\\\\n\\" : \\"+r\\" ( &ret), \\"=&r\\" ( &tmp), \\"+r\\" ( &tmp2), \\"+r\\" ($p), \\"+r\\" ($val) : : \\"cc\\", \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_fetchadd_32);
    eval 'sub atomic_fetchadd_64 {
        my($p,$val) = @_;
	    eval q({  &uint64_t  &ret,  &tmp;  &uint32_t  &exflag;  &__asm  &__volatile( \\"1:							\\\\n\\" \\"   ldrexd	%Q[ret], %R[ret], [%[ptr]]		\\\\n\\" \\"   adds	%Q[tmp], %Q[ret], %Q[val]		\\\\n\\" \\"   adc	%R[tmp], %R[ret], %R[val]		\\\\n\\" \\"   strexd	%[exf], %Q[tmp], %R[tmp], [%[ptr]]	\\\\n\\" \\"   teq	%[exf], #0				\\\\n\\" \\"   it	ne					\\\\n\\" \\"   bne	1b					\\\\n\\" : [ &ret] \\"=&r\\" ( &ret), [ &exf] \\"=&r\\" ( &exflag), [ &tmp] \\"=&r\\" ( &tmp) : [ &ptr] \\"r\\" ($p), [$val] \\"r\\" ($val) : \\"cc\\", \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_fetchadd_64);
    eval 'sub atomic_fetchadd_long {
        my($p,$val) = @_;
	    eval q({ ( &atomic_fetchadd_32(( &volatile  &uint32_t *)$p, $val)); });
    }' unless defined(&atomic_fetchadd_long);
    eval 'sub atomic_load_acq_32 {
        my($p) = @_;
	    eval q({  &uint32_t  &v;  &v = *$p;  &dmb(); ( &v); });
    }' unless defined(&atomic_load_acq_32);
    eval 'sub atomic_load_64 {
        my($p) = @_;
	    eval q({  &uint64_t  &ret;  &__asm  &__volatile( \\"ldrexd	%Q[ret], %R[ret], [%[ptr]]	\\\\n\\" \\"clrex					\\\\n\\" : [ &ret] \\"=&r\\" ( &ret) : [ &ptr] \\"r\\" ($p) : \\"cc\\", \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_load_64);
    eval 'sub atomic_load_acq_64 {
        my($p) = @_;
	    eval q({  &uint64_t  &ret;  &ret =  &atomic_load_64($p);  &dmb(); ( &ret); });
    }' unless defined(&atomic_load_acq_64);
    eval 'sub atomic_load_acq_long {
        my($p) = @_;
	    eval q({ my $v;  $v = *$p;  &dmb(); ( $v); });
    }' unless defined(&atomic_load_acq_long);
    eval 'sub atomic_readandclear_32 {
        my($p) = @_;
	    eval q({  &uint32_t  &ret,  &tmp = 0,  &tmp2 = 0;  &__asm  &__volatile( \\"1: ldrex	%0, [%3]	\\\\n\\" \\"   mov	%1, #0		\\\\n\\" \\"   strex	%2, %1, [%3]	\\\\n\\" \\"   cmp	%2, #0		\\\\n\\" \\"   it	ne		\\\\n\\" \\"   bne	1b		\\\\n\\" : \\"=r\\" ( &ret), \\"=&r\\" ( &tmp), \\"+r\\" ( &tmp2), \\"+r\\" ($p) : : \\"cc\\", \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_readandclear_32);
    eval 'sub atomic_readandclear_64 {
        my($p) = @_;
	    eval q({  &uint64_t  &ret,  &tmp;  &uint32_t  &exflag;  &__asm  &__volatile( \\"1:							\\\\n\\" \\"   ldrexd	%Q[ret], %R[ret], [%[ptr]]		\\\\n\\" \\"   mov	%Q[tmp], #0				\\\\n\\" \\"   mov	%R[tmp], #0				\\\\n\\" \\"   strexd	%[exf], %Q[tmp], %R[tmp], [%[ptr]]	\\\\n\\" \\"   teq	%[exf], #0				\\\\n\\" \\"   it	ne					\\\\n\\" \\"   bne	1b					\\\\n\\" : [ &ret] \\"=&r\\" ( &ret), [ &exf] \\"=&r\\" ( &exflag), [ &tmp] \\"=&r\\" ( &tmp) : [ &ptr] \\"r\\" ($p) : \\"cc\\", \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_readandclear_64);
    eval 'sub atomic_readandclear_long {
        my($p) = @_;
	    eval q({ ( &atomic_readandclear_32(( &volatile  &uint32_t *)$p)); });
    }' unless defined(&atomic_readandclear_long);
    eval 'sub atomic_set_32 {
        my($address,$setmask) = @_;
	    eval q({  &uint32_t  &tmp = 0,  &tmp2 = 0;  &__asm  &__volatile( \\"1: ldrex	%0, [%2]	\\\\n\\" \\"   orr	%0, %0, %3	\\\\n\\" \\"   strex	%1, %0, [%2]	\\\\n\\" \\"   cmp	%1, #0		\\\\n\\" \\"   it	ne		\\\\n\\" \\"   bne	1b		\\\\n\\" : \\"=&r\\" ( &tmp), \\"+r\\" ( &tmp2), \\"+r\\" ($address), \\"+r\\" ($setmask) : : \\"cc\\", \\"memory\\"); });
    }' unless defined(&atomic_set_32);
    eval 'sub atomic_set_64 {
        my($p,$val) = @_;
	    eval q({  &uint64_t  &tmp;  &uint32_t  &exflag;  &__asm  &__volatile( \\"1:							\\\\n\\" \\"   ldrexd	%Q[tmp], %R[tmp], [%[ptr]]		\\\\n\\" \\"   orr	%Q[tmp], %Q[val]			\\\\n\\" \\"   orr	%R[tmp], %R[val]			\\\\n\\" \\"   strexd	%[exf], %Q[tmp], %R[tmp], [%[ptr]]	\\\\n\\" \\"   teq	%[exf], #0				\\\\n\\" \\"   it	ne					\\\\n\\" \\"   bne	1b					\\\\n\\" : [ &exf] \\"=&r\\" ( &exflag), [ &tmp] \\"=&r\\" ( &tmp) : [ &ptr] \\"r\\" ($p), [$val] \\"r\\" ($val) : \\"cc\\", \\"memory\\"); });
    }' unless defined(&atomic_set_64);
    eval 'sub atomic_set_long {
        my($address,$setmask) = @_;
	    eval q({  &atomic_set_32(( &volatile  &uint32_t *)$address, $setmask); });
    }' unless defined(&atomic_set_long);
    eval 'sub atomic_subtract_32 {
        my($p,$val) = @_;
	    eval q({  &uint32_t  &tmp = 0,  &tmp2 = 0;  &__asm  &__volatile( \\"1: ldrex	%0, [%2]	\\\\n\\" \\"   sub	%0, %0, %3	\\\\n\\" \\"   strex	%1, %0, [%2]	\\\\n\\" \\"   cmp	%1, #0		\\\\n\\" \\"   it	ne		\\\\n\\" \\"   bne	1b		\\\\n\\" : \\"=&r\\" ( &tmp), \\"+r\\" ( &tmp2), \\"+r\\" ($p), \\"+r\\" ($val) : : \\"cc\\", \\"memory\\"); });
    }' unless defined(&atomic_subtract_32);
    eval 'sub atomic_subtract_64 {
        my($p,$val) = @_;
	    eval q({  &uint64_t  &tmp;  &uint32_t  &exflag;  &__asm  &__volatile( \\"1:							\\\\n\\" \\"   ldrexd	%Q[tmp], %R[tmp], [%[ptr]]		\\\\n\\" \\"   subs	%Q[tmp], %Q[val]			\\\\n\\" \\"   sbc	%R[tmp], %R[tmp], %R[val]		\\\\n\\" \\"   strexd	%[exf], %Q[tmp], %R[tmp], [%[ptr]]	\\\\n\\" \\"   teq	%[exf], #0				\\\\n\\" \\"   it	ne					\\\\n\\" \\"   bne	1b					\\\\n\\" : [ &exf] \\"=&r\\" ( &exflag), [ &tmp] \\"=&r\\" ( &tmp) : [ &ptr] \\"r\\" ($p), [$val] \\"r\\" ($val) : \\"cc\\", \\"memory\\"); });
    }' unless defined(&atomic_subtract_64);
    eval 'sub atomic_subtract_long {
        my($p,$val) = @_;
	    eval q({  &atomic_subtract_32(( &volatile  &uint32_t *)$p, $val); });
    }' unless defined(&atomic_subtract_long);
    eval 'sub atomic_store_64 {
        my($p,$val) = @_;
	    eval q({  &uint64_t  &tmp;  &uint32_t  &exflag;  &__asm  &__volatile( \\"1:							\\\\n\\" \\"   ldrexd	%Q[tmp], %R[tmp], [%[ptr]]		\\\\n\\" \\"   strexd	%[exf], %Q[val], %R[val], [%[ptr]]	\\\\n\\" \\"   teq	%[exf], #0				\\\\n\\" \\"   it	ne					\\\\n\\" \\"   bne	1b					\\\\n\\" : [ &tmp] \\"=&r\\" ( &tmp), [ &exf] \\"=&r\\" ( &exflag) : [ &ptr] \\"r\\" ($p), [$val] \\"r\\" ($val) : \\"cc\\", \\"memory\\"); });
    }' unless defined(&atomic_store_64);
    eval 'sub atomic_store_rel_32 {
        my($p,$v) = @_;
	    eval q({  &dmb(); *$p = $v; });
    }' unless defined(&atomic_store_rel_32);
    eval 'sub atomic_store_rel_64 {
        my($p,$val) = @_;
	    eval q({  &dmb();  &atomic_store_64($p, $val); });
    }' unless defined(&atomic_store_rel_64);
    eval 'sub atomic_store_rel_long {
        my($p,$v) = @_;
	    eval q({  &dmb(); *$p = $v; });
    }' unless defined(&atomic_store_rel_long);
    eval 'sub atomic_testandset_32 {
        my($p,$v) = @_;
	    eval q({  &uint32_t  &tmp,  &tmp2,  &res,  &mask;  &mask = 1 << ($v & 0x1f);  &tmp =  &tmp2 = 0;  &__asm  &__volatile( \\"1:	ldrex	%0, [%4]	\\\\n\\" \\"	orr	%1, %0, %3	\\\\n\\" \\"	strex	%2, %1, [%4]	\\\\n\\" \\"	cmp	%2, #0		\\\\n\\" \\"	it	ne		\\\\n\\" \\"	bne	1b		\\\\n\\" : \\"=&r\\" ( &res), \\"=&r\\" ( &tmp), \\"=&r\\" ( &tmp2) : \\"r\\" ( &mask), \\"r\\" ($p) : \\"cc\\", \\"memory\\"); (( &res &  &mask) != 0); });
    }' unless defined(&atomic_testandset_32);
    eval 'sub atomic_testandset_int {
        my($p,$v) = @_;
	    eval q({ ( &atomic_testandset_32(( &volatile  &uint32_t *)$p, $v)); });
    }' unless defined(&atomic_testandset_int);
    eval 'sub atomic_testandset_long {
        my($p,$v) = @_;
	    eval q({ ( &atomic_testandset_32(( &volatile  &uint32_t *)$p, $v)); });
    }' unless defined(&atomic_testandset_long);
    eval 'sub atomic_testandset_64 {
        my($p,$v) = @_;
	    eval q({  &volatile  &uint32_t * &p32;  &p32 = ( &volatile  &uint32_t *)$p;  &if ($v >= 32) { $v &= 0x1f;  &p32++; } ( &atomic_testandset_32( &p32, $v)); });
    }' unless defined(&atomic_testandset_64);
    eval 'sub atomic_swap_32 {
        my($p,$v) = @_;
	    eval q({  &uint32_t  &ret,  &exflag;  &__asm  &__volatile( \\"1: ldrex	%[ret], [%[ptr]]		\\\\n\\" \\"   strex	%[exf], %[val], [%[ptr]]	\\\\n\\" \\"   teq	%[exf], #0			\\\\n\\" \\"   it	ne				\\\\n\\" \\"   bne	1b				\\\\n\\" : [ &ret] \\"=&r\\" ( &ret), [ &exf] \\"=&r\\" ( &exflag) : [ &val] \\"r\\" ($v), [ &ptr] \\"r\\" ($p) : \\"cc\\", \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_swap_32);
    eval 'sub atomic_swap_64 {
        my($p,$v) = @_;
	    eval q({  &uint64_t  &ret;  &uint32_t  &exflag;  &__asm  &__volatile( \\"1: ldrexd	%Q[ret], %R[ret], [%[ptr]]		\\\\n\\" \\"   strexd	%[exf], %Q[val], %R[val], [%[ptr]]	\\\\n\\" \\"   teq	%[exf], #0				\\\\n\\" \\"   it	ne					\\\\n\\" \\"   bne	1b					\\\\n\\" : [ &ret] \\"=&r\\" ( &ret), [ &exf] \\"=&r\\" ( &exflag) : [ &val] \\"r\\" ($v), [ &ptr] \\"r\\" ($p) : \\"cc\\", \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_swap_64);
    undef(&ATOMIC_ACQ_REL) if defined(&ATOMIC_ACQ_REL);
    undef(&ATOMIC_ACQ_REL_LONG) if defined(&ATOMIC_ACQ_REL_LONG);
    eval 'sub atomic_thread_fence_acq {
        my($void) = @_;
	    eval q({  &dmb(); });
    }' unless defined(&atomic_thread_fence_acq);
    eval 'sub atomic_thread_fence_rel {
        my($void) = @_;
	    eval q({  &dmb(); });
    }' unless defined(&atomic_thread_fence_rel);
    eval 'sub atomic_thread_fence_acq_rel {
        my($void) = @_;
	    eval q({  &dmb(); });
    }' unless defined(&atomic_thread_fence_acq_rel);
    eval 'sub atomic_thread_fence_seq_cst {
        my($void) = @_;
	    eval q({  &dmb(); });
    }' unless defined(&atomic_thread_fence_seq_cst);
}
1;
