require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ATOMIC_H_)) {
    eval 'sub _MACHINE_ATOMIC_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_H_);
    require 'sys/atomic_common.ph';
    require 'machine/armreg.ph';
    unless(defined(&_KERNEL)) {
	require 'machine/sysarch.ph';
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	require 'machine/atomic-v6.ph';
    } else {
	require 'machine/atomic-v4.ph';
    }
    eval 'sub atomic_swap_long {
        my($p,$v) = @_;
	    eval q({ ( &atomic_swap_32(( &volatile  &uint32_t *)$p, $v)); });
    }' unless defined(&atomic_swap_long);
    eval 'sub atomic_clear_ptr () { &atomic_clear_32;}' unless defined(&atomic_clear_ptr);
    eval 'sub atomic_clear_acq_ptr () { &atomic_clear_acq_32;}' unless defined(&atomic_clear_acq_ptr);
    eval 'sub atomic_clear_rel_ptr () { &atomic_clear_rel_32;}' unless defined(&atomic_clear_rel_ptr);
    eval 'sub atomic_set_ptr () { &atomic_set_32;}' unless defined(&atomic_set_ptr);
    eval 'sub atomic_set_acq_ptr () { &atomic_set_acq_32;}' unless defined(&atomic_set_acq_ptr);
    eval 'sub atomic_set_rel_ptr () { &atomic_set_rel_32;}' unless defined(&atomic_set_rel_ptr);
    eval 'sub atomic_fcmpset_ptr () { &atomic_fcmpset_32;}' unless defined(&atomic_fcmpset_ptr);
    eval 'sub atomic_fcmpset_rel_ptr () { &atomic_fcmpset_rel_32;}' unless defined(&atomic_fcmpset_rel_ptr);
    eval 'sub atomic_fcmpset_acq_ptr () { &atomic_fcmpset_acq_32;}' unless defined(&atomic_fcmpset_acq_ptr);
    eval 'sub atomic_cmpset_ptr () { &atomic_cmpset_32;}' unless defined(&atomic_cmpset_ptr);
    eval 'sub atomic_cmpset_acq_ptr () { &atomic_cmpset_acq_32;}' unless defined(&atomic_cmpset_acq_ptr);
    eval 'sub atomic_cmpset_rel_ptr () { &atomic_cmpset_rel_32;}' unless defined(&atomic_cmpset_rel_ptr);
    eval 'sub atomic_load_acq_ptr () { &atomic_load_acq_32;}' unless defined(&atomic_load_acq_ptr);
    eval 'sub atomic_store_rel_ptr () { &atomic_store_rel_32;}' unless defined(&atomic_store_rel_ptr);
    eval 'sub atomic_swap_ptr () { &atomic_swap_32;}' unless defined(&atomic_swap_ptr);
    eval 'sub atomic_readandclear_ptr () { &atomic_readandclear_32;}' unless defined(&atomic_readandclear_ptr);
    eval 'sub atomic_add_int () { &atomic_add_32;}' unless defined(&atomic_add_int);
    eval 'sub atomic_add_acq_int () { &atomic_add_acq_32;}' unless defined(&atomic_add_acq_int);
    eval 'sub atomic_add_rel_int () { &atomic_add_rel_32;}' unless defined(&atomic_add_rel_int);
    eval 'sub atomic_subtract_int () { &atomic_subtract_32;}' unless defined(&atomic_subtract_int);
    eval 'sub atomic_subtract_acq_int () { &atomic_subtract_acq_32;}' unless defined(&atomic_subtract_acq_int);
    eval 'sub atomic_subtract_rel_int () { &atomic_subtract_rel_32;}' unless defined(&atomic_subtract_rel_int);
    eval 'sub atomic_clear_int () { &atomic_clear_32;}' unless defined(&atomic_clear_int);
    eval 'sub atomic_clear_acq_int () { &atomic_clear_acq_32;}' unless defined(&atomic_clear_acq_int);
    eval 'sub atomic_clear_rel_int () { &atomic_clear_rel_32;}' unless defined(&atomic_clear_rel_int);
    eval 'sub atomic_set_int () { &atomic_set_32;}' unless defined(&atomic_set_int);
    eval 'sub atomic_set_acq_int () { &atomic_set_acq_32;}' unless defined(&atomic_set_acq_int);
    eval 'sub atomic_set_rel_int () { &atomic_set_rel_32;}' unless defined(&atomic_set_rel_int);
    eval 'sub atomic_fcmpset_int () { &atomic_fcmpset_32;}' unless defined(&atomic_fcmpset_int);
    eval 'sub atomic_fcmpset_acq_int () { &atomic_fcmpset_acq_32;}' unless defined(&atomic_fcmpset_acq_int);
    eval 'sub atomic_fcmpset_rel_int () { &atomic_fcmpset_rel_32;}' unless defined(&atomic_fcmpset_rel_int);
    eval 'sub atomic_cmpset_int () { &atomic_cmpset_32;}' unless defined(&atomic_cmpset_int);
    eval 'sub atomic_cmpset_acq_int () { &atomic_cmpset_acq_32;}' unless defined(&atomic_cmpset_acq_int);
    eval 'sub atomic_cmpset_rel_int () { &atomic_cmpset_rel_32;}' unless defined(&atomic_cmpset_rel_int);
    eval 'sub atomic_fetchadd_int () { &atomic_fetchadd_32;}' unless defined(&atomic_fetchadd_int);
    eval 'sub atomic_readandclear_int () { &atomic_readandclear_32;}' unless defined(&atomic_readandclear_int);
    eval 'sub atomic_load_acq_int () { &atomic_load_acq_32;}' unless defined(&atomic_load_acq_int);
    eval 'sub atomic_store_rel_int () { &atomic_store_rel_32;}' unless defined(&atomic_store_rel_int);
    eval 'sub atomic_swap_int () { &atomic_swap_32;}' unless defined(&atomic_swap_int);
}
1;
