require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_BUS_H_)) {
    eval 'sub _MACHINE_BUS_H_ () {1;}' unless defined(&_MACHINE_BUS_H_);
    require 'machine/_bus.ph';
    eval 'sub BUS_SPACE_MAP_CACHEABLE () {0x1;}' unless defined(&BUS_SPACE_MAP_CACHEABLE);
    eval 'sub BUS_SPACE_MAP_LINEAR () {0x2;}' unless defined(&BUS_SPACE_MAP_LINEAR);
    eval 'sub BUS_SPACE_MAP_PREFETCHABLE () {0x4;}' unless defined(&BUS_SPACE_MAP_PREFETCHABLE);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) < 6) {
    }
    eval 'sub __bs_c {
        my($a,$b) = @_;
	    eval q( &__CONCAT($a,$b));
    }' unless defined(&__bs_c);
    eval 'sub __bs_opname {
        my($op,$size) = @_;
	    eval q( &__bs_c( &__bs_c( &__bs_c( &bs_,$op), &_),$size));
    }' unless defined(&__bs_opname);
    eval 'sub __bs_nonsingle {
        my($type, $sz, $t, $h, $o, $a, $c) = @_;
	    eval q((*($t)-> &__bs_opname($type,$sz))(($t), $h, $o, $a, $c));
    }' unless defined(&__bs_nonsingle);
    eval 'sub __bs_set {
        my($type, $sz, $t, $h, $o, $v, $c) = @_;
	    eval q((*($t)-> &__bs_opname($type,$sz))(($t), $h, $o, $v, $c));
    }' unless defined(&__bs_set);
    eval 'sub __bs_copy {
        my($sz, $t, $h1, $o1, $h2, $o2, $cnt) = @_;
	    eval q((*($t)-> &__bs_opname( &c,$sz))(($t), $h1, $o1, $h2, $o2, $cnt));
    }' unless defined(&__bs_copy);
    eval 'sub __bs_opname_s {
        my($op,$size) = @_;
	    eval q( &__bs_c( &__bs_c( &__bs_c( &__bs_c( &bs_,$op), &_),$size), &_s));
    }' unless defined(&__bs_opname_s);
    eval 'sub __bs_rs_s {
        my($sz, $t, $h, $o) = @_;
	    eval q((*($t)-> &__bs_opname_s( &r,$sz))(($t), $h, $o));
    }' unless defined(&__bs_rs_s);
    eval 'sub __bs_ws_s {
        my($sz, $t, $h, $o, $v) = @_;
	    eval q((*($t)-> &__bs_opname_s( &w,$sz))(($t), $h, $o, $v));
    }' unless defined(&__bs_ws_s);
    eval 'sub __bs_nonsingle_s {
        my($type, $sz, $t, $h, $o, $a, $c) = @_;
	    eval q((*($t)-> &__bs_opname_s($type,$sz))(($t), $h, $o, $a, $c));
    }' unless defined(&__bs_nonsingle_s);
    eval 'sub __generate_inline_bs_rs {
        my($IFN, $MBR, $TYP) = @_;
	    eval q( &static  &inline $TYP $IFN( &bus_space_tag_t  &t,  &bus_space_handle_t  &h,  &bus_size_t  &o) {  &if ( &__predict_true( ($t->{MBR}) ==  &NULL))  &return (*( &volatile $TYP *)( &h +  &o));  &else  &return ( ($t->{MBR})( &t,  &h,  &o)); });
    }' unless defined(&__generate_inline_bs_rs);
    eval 'sub __generate_inline_bs_ws {
        my($IFN, $MBR, $TYP) = @_;
	    eval q( &static  &inline  &void $IFN( &bus_space_tag_t  &t,  &bus_space_handle_t  &h,  &bus_size_t  &o, $TYP  &v) {  &if ( &__predict_true( ($t->{MBR}) ==  &NULL)) *( &volatile $TYP *)( &h +  &o) =  &v;  &else  ($t->{MBR})( &t,  &h,  &o,  &v); });
    }' unless defined(&__generate_inline_bs_ws);
    eval 'sub bus_space_map {
        my($t, $a, $s, $c, $hp) = @_;
	    eval q((*($t)-> &bs_map)(($t), ($a), ($s), ($c), ($hp)));
    }' unless defined(&bus_space_map);
    eval 'sub bus_space_unmap {
        my($t, $h, $s) = @_;
	    eval q((*($t)-> &bs_unmap)(($t), ($h), ($s)));
    }' unless defined(&bus_space_unmap);
    eval 'sub bus_space_subregion {
        my($t, $h, $o, $s, $hp) = @_;
	    eval q((*($t)-> &bs_subregion)(($t), ($h), ($o), ($s), ($hp)));
    }' unless defined(&bus_space_subregion);
    eval 'sub bus_space_alloc {
        my($t, $rs, $re, $s, $a, $b, $c, $ap, $hp) = @_;
	    eval q((*($t)-> &bs_alloc)(($t), ($rs), ($re), ($s), ($a), ($b), ($c), ($ap), ($hp)));
    }' unless defined(&bus_space_alloc);
    eval 'sub bus_space_free {
        my($t, $h, $s) = @_;
	    eval q((*($t)-> &bs_free)(($t), ($h), ($s)));
    }' unless defined(&bus_space_free);
    eval 'sub bus_space_barrier {
        my($t, $h, $o, $l, $f) = @_;
	    eval q((*($t)-> &bs_barrier)(($t), ($h), ($o), ($l), ($f)));
    }' unless defined(&bus_space_barrier);
    eval 'sub BUS_SPACE_BARRIER_READ () {0x1;}' unless defined(&BUS_SPACE_BARRIER_READ);
    eval 'sub BUS_SPACE_BARRIER_WRITE () {0x2;}' unless defined(&BUS_SPACE_BARRIER_WRITE);
    eval 'sub bus_space_read_multi_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &rm,1,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_multi_1);
    eval 'sub bus_space_read_multi_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &rm,2,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_multi_2);
    eval 'sub bus_space_read_multi_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &rm,4,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_multi_4);
    eval 'sub bus_space_read_multi_8 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &rm,8,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_multi_8);
    eval 'sub bus_space_read_multi_stream_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &rm,1,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_multi_stream_1);
    eval 'sub bus_space_read_multi_stream_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &rm,2,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_multi_stream_2);
    eval 'sub bus_space_read_multi_stream_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &rm,4,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_multi_stream_4);
    eval 'sub bus_space_read_multi_stream_8 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &rm,8,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_multi_stream_8);
    eval 'sub bus_space_read_region_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &rr,1,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_region_1);
    eval 'sub bus_space_read_region_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &rr,2,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_region_2);
    eval 'sub bus_space_read_region_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &rr,4,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_region_4);
    eval 'sub bus_space_read_region_8 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &rr,8,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_region_8);
    eval 'sub bus_space_read_region_stream_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &rr,1,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_region_stream_1);
    eval 'sub bus_space_read_region_stream_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &rr,2,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_region_stream_2);
    eval 'sub bus_space_read_region_stream_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &rr,4,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_region_stream_4);
    eval 'sub bus_space_read_region_stream_8 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &rr,8,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_read_region_stream_8);
    eval 'sub bus_space_write_multi_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &wm,1,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_multi_1);
    eval 'sub bus_space_write_multi_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &wm,2,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_multi_2);
    eval 'sub bus_space_write_multi_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &wm,4,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_multi_4);
    eval 'sub bus_space_write_multi_8 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &wm,8,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_multi_8);
    eval 'sub bus_space_write_multi_stream_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &wm,1,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_multi_stream_1);
    eval 'sub bus_space_write_multi_stream_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &wm,2,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_multi_stream_2);
    eval 'sub bus_space_write_multi_stream_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &wm,4,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_multi_stream_4);
    eval 'sub bus_space_write_multi_stream_8 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &wm,8,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_multi_stream_8);
    eval 'sub bus_space_write_region_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &wr,1,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_region_1);
    eval 'sub bus_space_write_region_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &wr,2,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_region_2);
    eval 'sub bus_space_write_region_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &wr,4,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_region_4);
    eval 'sub bus_space_write_region_8 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle( &wr,8,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_region_8);
    eval 'sub bus_space_write_region_stream_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &wr,1,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_region_stream_1);
    eval 'sub bus_space_write_region_stream_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &wr,2,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_region_stream_2);
    eval 'sub bus_space_write_region_stream_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &wr,4,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_region_stream_4);
    eval 'sub bus_space_write_region_stream_8 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &__bs_nonsingle_s( &wr,8,($t),($h),($o),($a),($c)));
    }' unless defined(&bus_space_write_region_stream_8);
    eval 'sub bus_space_set_multi_1 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &__bs_set( &sm,1,($t),($h),($o),($v),($c)));
    }' unless defined(&bus_space_set_multi_1);
    eval 'sub bus_space_set_multi_2 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &__bs_set( &sm,2,($t),($h),($o),($v),($c)));
    }' unless defined(&bus_space_set_multi_2);
    eval 'sub bus_space_set_multi_4 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &__bs_set( &sm,4,($t),($h),($o),($v),($c)));
    }' unless defined(&bus_space_set_multi_4);
    eval 'sub bus_space_set_multi_8 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &__bs_set( &sm,8,($t),($h),($o),($v),($c)));
    }' unless defined(&bus_space_set_multi_8);
    eval 'sub bus_space_set_region_1 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &__bs_set( &sr,1,($t),($h),($o),($v),($c)));
    }' unless defined(&bus_space_set_region_1);
    eval 'sub bus_space_set_region_2 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &__bs_set( &sr,2,($t),($h),($o),($v),($c)));
    }' unless defined(&bus_space_set_region_2);
    eval 'sub bus_space_set_region_4 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &__bs_set( &sr,4,($t),($h),($o),($v),($c)));
    }' unless defined(&bus_space_set_region_4);
    eval 'sub bus_space_set_region_8 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &__bs_set( &sr,8,($t),($h),($o),($v),($c)));
    }' unless defined(&bus_space_set_region_8);
    eval 'sub bus_space_copy_region_1 {
        my($t, $h1, $o1, $h2, $o2, $c) = @_;
	    eval q( &__bs_copy(1, $t, $h1, $o1, $h2, $o2, $c));
    }' unless defined(&bus_space_copy_region_1);
    eval 'sub bus_space_copy_region_2 {
        my($t, $h1, $o1, $h2, $o2, $c) = @_;
	    eval q( &__bs_copy(2, $t, $h1, $o1, $h2, $o2, $c));
    }' unless defined(&bus_space_copy_region_2);
    eval 'sub bus_space_copy_region_4 {
        my($t, $h1, $o1, $h2, $o2, $c) = @_;
	    eval q( &__bs_copy(4, $t, $h1, $o1, $h2, $o2, $c));
    }' unless defined(&bus_space_copy_region_4);
    eval 'sub bus_space_copy_region_8 {
        my($t, $h1, $o1, $h2, $o2, $c) = @_;
	    eval q( &__bs_copy(8, $t, $h1, $o1, $h2, $o2, $c));
    }' unless defined(&bus_space_copy_region_8);
    eval 'sub bs_map_proto {
        my($f) = @_;
	    eval q(\'int\'  &__bs_c($f, &_bs_map) ( &bus_space_tag_t  &t,  &bus_addr_t  &addr,  &bus_size_t  &size, \'int\'  &cacheable,  &bus_space_handle_t * &bshp););
    }' unless defined(&bs_map_proto);
    eval 'sub bs_unmap_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_unmap) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &size););
    }' unless defined(&bs_unmap_proto);
    eval 'sub bs_subregion_proto {
        my($f) = @_;
	    eval q(\'int\'  &__bs_c($f, &_bs_subregion) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &bus_size_t  &size,  &bus_space_handle_t * &nbshp););
    }' unless defined(&bs_subregion_proto);
    eval 'sub bs_alloc_proto {
        my($f) = @_;
	    eval q(\'int\'  &__bs_c($f, &_bs_alloc) ( &bus_space_tag_t  &t,  &bus_addr_t  &rstart,  &bus_addr_t  &rend,  &bus_size_t  &size,  &bus_size_t  &align,  &bus_size_t  &boundary, \'int\'  &cacheable,  &bus_addr_t * &addrp,  &bus_space_handle_t * &bshp););
    }' unless defined(&bs_alloc_proto);
    eval 'sub bs_free_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_free) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &size););
    }' unless defined(&bs_free_proto);
    eval 'sub bs_mmap_proto {
        my($f) = @_;
	    eval q(\'int\'  &__bs_c($f, &_bs_mmap) (\'struct cdev\' *,  &vm_offset_t,  &vm_paddr_t *, \'int\'););
    }' unless defined(&bs_mmap_proto);
    eval 'sub bs_barrier_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_barrier) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &bus_size_t  &len, \'int\'  &flags););
    }' unless defined(&bs_barrier_proto);
    eval 'sub bs_r_1_proto {
        my($f) = @_;
	    eval q( &uint8_t  &__bs_c($f, &_bs_r_1) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset););
    }' unless defined(&bs_r_1_proto);
    eval 'sub bs_r_2_proto {
        my($f) = @_;
	    eval q( &uint16_t  &__bs_c($f, &_bs_r_2) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset););
    }' unless defined(&bs_r_2_proto);
    eval 'sub bs_r_4_proto {
        my($f) = @_;
	    eval q( &uint32_t  &__bs_c($f, &_bs_r_4) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset););
    }' unless defined(&bs_r_4_proto);
    eval 'sub bs_r_8_proto {
        my($f) = @_;
	    eval q( &uint64_t  &__bs_c($f, &_bs_r_8) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset););
    }' unless defined(&bs_r_8_proto);
    eval 'sub bs_r_1_s_proto {
        my($f) = @_;
	    eval q( &uint8_t  &__bs_c($f, &_bs_r_1_s) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset););
    }' unless defined(&bs_r_1_s_proto);
    eval 'sub bs_r_2_s_proto {
        my($f) = @_;
	    eval q( &uint16_t  &__bs_c($f, &_bs_r_2_s) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset););
    }' unless defined(&bs_r_2_s_proto);
    eval 'sub bs_r_4_s_proto {
        my($f) = @_;
	    eval q( &uint32_t  &__bs_c($f, &_bs_r_4_s) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset););
    }' unless defined(&bs_r_4_s_proto);
    eval 'sub bs_w_1_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_w_1) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint8_t  &value););
    }' unless defined(&bs_w_1_proto);
    eval 'sub bs_w_2_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_w_2) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint16_t  &value););
    }' unless defined(&bs_w_2_proto);
    eval 'sub bs_w_4_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_w_4) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint32_t  &value););
    }' unless defined(&bs_w_4_proto);
    eval 'sub bs_w_8_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_w_8) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint64_t  &value););
    }' unless defined(&bs_w_8_proto);
    eval 'sub bs_w_1_s_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_w_1_s) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint8_t  &value););
    }' unless defined(&bs_w_1_s_proto);
    eval 'sub bs_w_2_s_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_w_2_s) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint16_t  &value););
    }' unless defined(&bs_w_2_s_proto);
    eval 'sub bs_w_4_s_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_w_4_s) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint32_t  &value););
    }' unless defined(&bs_w_4_s_proto);
    eval 'sub bs_rm_1_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_rm_1) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint8_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_rm_1_proto);
    eval 'sub bs_rm_2_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_rm_2) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint16_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_rm_2_proto);
    eval 'sub bs_rm_4_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_rm_4) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint32_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_rm_4_proto);
    eval 'sub bs_rm_8_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_rm_8) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint64_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_rm_8_proto);
    eval 'sub bs_wm_1_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_wm_1) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &const  &uint8_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_wm_1_proto);
    eval 'sub bs_wm_2_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_wm_2) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &const  &uint16_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_wm_2_proto);
    eval 'sub bs_wm_4_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_wm_4) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &const  &uint32_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_wm_4_proto);
    eval 'sub bs_wm_8_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_wm_8) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &const  &uint64_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_wm_8_proto);
    eval 'sub bs_rr_1_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f,  &_bs_rr_1) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint8_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_rr_1_proto);
    eval 'sub bs_rr_2_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f,  &_bs_rr_2) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint16_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_rr_2_proto);
    eval 'sub bs_rr_4_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f,  &_bs_rr_4) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint32_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_rr_4_proto);
    eval 'sub bs_rr_8_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f,  &_bs_rr_8) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint64_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_rr_8_proto);
    eval 'sub bs_wr_1_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f,  &_bs_wr_1) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &const  &uint8_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_wr_1_proto);
    eval 'sub bs_wr_2_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f,  &_bs_wr_2) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &const  &uint16_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_wr_2_proto);
    eval 'sub bs_wr_4_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f,  &_bs_wr_4) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &const  &uint32_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_wr_4_proto);
    eval 'sub bs_wr_8_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f,  &_bs_wr_8) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &const  &uint64_t * &addr,  &bus_size_t  &count););
    }' unless defined(&bs_wr_8_proto);
    eval 'sub bs_sm_1_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_sm_1) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint8_t  &value,  &bus_size_t  &count););
    }' unless defined(&bs_sm_1_proto);
    eval 'sub bs_sm_2_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_sm_2) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint16_t  &value,  &bus_size_t  &count););
    }' unless defined(&bs_sm_2_proto);
    eval 'sub bs_sm_4_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_sm_4) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint32_t  &value,  &bus_size_t  &count););
    }' unless defined(&bs_sm_4_proto);
    eval 'sub bs_sm_8_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_sm_8) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint64_t  &value,  &bus_size_t  &count););
    }' unless defined(&bs_sm_8_proto);
    eval 'sub bs_sr_1_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_sr_1) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint8_t  &value,  &bus_size_t  &count););
    }' unless defined(&bs_sr_1_proto);
    eval 'sub bs_sr_2_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_sr_2) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint16_t  &value,  &bus_size_t  &count););
    }' unless defined(&bs_sr_2_proto);
    eval 'sub bs_sr_4_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_sr_4) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint32_t  &value,  &bus_size_t  &count););
    }' unless defined(&bs_sr_4_proto);
    eval 'sub bs_sr_8_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_sr_8) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh,  &bus_size_t  &offset,  &uint64_t  &value,  &bus_size_t  &count););
    }' unless defined(&bs_sr_8_proto);
    eval 'sub bs_c_1_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_c_1) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh1,  &bus_size_t  &offset1,  &bus_space_handle_t  &bsh2,  &bus_size_t  &offset2,  &bus_size_t  &count););
    }' unless defined(&bs_c_1_proto);
    eval 'sub bs_c_2_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_c_2) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh1,  &bus_size_t  &offset1,  &bus_space_handle_t  &bsh2,  &bus_size_t  &offset2,  &bus_size_t  &count););
    }' unless defined(&bs_c_2_proto);
    eval 'sub bs_c_4_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_c_4) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh1,  &bus_size_t  &offset1,  &bus_space_handle_t  &bsh2,  &bus_size_t  &offset2,  &bus_size_t  &count););
    }' unless defined(&bs_c_4_proto);
    eval 'sub bs_c_8_proto {
        my($f) = @_;
	    eval q( &void  &__bs_c($f, &_bs_c_8) ( &bus_space_tag_t  &t,  &bus_space_handle_t  &bsh1,  &bus_size_t  &offset1,  &bus_space_handle_t  &bsh2,  &bus_size_t  &offset2,  &bus_size_t  &count););
    }' unless defined(&bs_c_8_proto);
    eval 'sub bs_protos {
        my($f) = @_;
	    eval q( &bs_map_proto($f);  &bs_unmap_proto($f);  &bs_subregion_proto($f);  &bs_alloc_proto($f);  &bs_free_proto($f);  &bs_mmap_proto($f);  &bs_barrier_proto($f);  &bs_r_1_proto($f);  &bs_r_2_proto($f);  &bs_r_4_proto($f);  &bs_r_8_proto($f);  &bs_r_1_s_proto($f);  &bs_r_2_s_proto($f);  &bs_r_4_s_proto($f);  &bs_w_1_proto($f);  &bs_w_2_proto($f);  &bs_w_4_proto($f);  &bs_w_8_proto($f);  &bs_w_1_s_proto($f);  &bs_w_2_s_proto($f);  &bs_w_4_s_proto($f);  &bs_rm_1_proto($f);  &bs_rm_2_proto($f);  &bs_rm_4_proto($f);  &bs_rm_8_proto($f);  &bs_wm_1_proto($f);  &bs_wm_2_proto($f);  &bs_wm_4_proto($f);  &bs_wm_8_proto($f);  &bs_rr_1_proto($f);  &bs_rr_2_proto($f);  &bs_rr_4_proto($f);  &bs_rr_8_proto($f);  &bs_wr_1_proto($f);  &bs_wr_2_proto($f);  &bs_wr_4_proto($f);  &bs_wr_8_proto($f);  &bs_sm_1_proto($f);  &bs_sm_2_proto($f);  &bs_sm_4_proto($f);  &bs_sm_8_proto($f);  &bs_sr_1_proto($f);  &bs_sr_2_proto($f);  &bs_sr_4_proto($f);  &bs_sr_8_proto($f);  &bs_c_1_proto($f);  &bs_c_2_proto($f);  &bs_c_4_proto($f);  &bs_c_8_proto($f););
    }' unless defined(&bs_protos);
    eval 'sub BS_UNIMPLEMENTED () {( &void *) &generic_bs_unimplemented;}' unless defined(&BS_UNIMPLEMENTED);
    eval 'sub BUS_SPACE_ALIGNED_POINTER {
        my($p, $t) = @_;
	    eval q( &ALIGNED_POINTER($p, $t));
    }' unless defined(&BUS_SPACE_ALIGNED_POINTER);
    eval 'sub BUS_SPACE_MAXADDR_24BIT () {0xffffff;}' unless defined(&BUS_SPACE_MAXADDR_24BIT);
    eval 'sub BUS_SPACE_MAXADDR_32BIT () {0xffffffff;}' unless defined(&BUS_SPACE_MAXADDR_32BIT);
    eval 'sub BUS_SPACE_MAXADDR () {0xffffffff;}' unless defined(&BUS_SPACE_MAXADDR);
    eval 'sub BUS_SPACE_MAXSIZE_24BIT () {0xffffff;}' unless defined(&BUS_SPACE_MAXSIZE_24BIT);
    eval 'sub BUS_SPACE_MAXSIZE_32BIT () {0xffffffff;}' unless defined(&BUS_SPACE_MAXSIZE_32BIT);
    eval 'sub BUS_SPACE_MAXSIZE () {0xffffffff;}' unless defined(&BUS_SPACE_MAXSIZE);
    eval 'sub BUS_SPACE_UNRESTRICTED () {(~0);}' unless defined(&BUS_SPACE_UNRESTRICTED);
    require 'machine/bus_dma.ph';
    eval 'sub BUS_SPACE_PHYSADDR {
        my($res, $offs) = @_;
	    eval q((( &rman_get_start($res)+($offs))));
    }' unless defined(&BUS_SPACE_PHYSADDR);
}
1;
