require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MACHINE_CPU_V4_H)) {
    eval 'sub MACHINE_CPU_V4_H () {1;}' unless defined(&MACHINE_CPU_V4_H);
    unless(defined(&_KERNEL)) {
	die("Only\ include\ this\ file\ in\ the\ kernel");
    }
    require 'machine/atomic.ph';
    require 'machine/cpufunc.ph';
    require 'machine/cpuinfo.ph';
    require 'machine/sysreg.ph';
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	die("Never\ include\ this\ file\ for\ ARMv6");
    } else {
	eval 'sub CPU_ASID_KERNEL () {0;}' unless defined(&CPU_ASID_KERNEL);
	eval 'sub _FX () {( &s...)  &s;}' unless defined(&_FX);
	eval 'sub _RF0 () {( &fname,  &aname...)  &static  &__inline  &uint32_t  &fname( &void) {  &uint32_t  &reg;  &__asm  &__volatile("mrc\\t"  &_FX( &aname): "=r" ( &reg));  &return( &reg); };}' unless defined(&_RF0);
	eval 'sub _R64F0 {
	    my($fname, $aname) = @_;
    	    eval q( &static  &__inline  &uint64_t $fname( &void) {  &uint64_t  &reg;  &__asm  &__volatile(\\"mrrc\\\\t\\"  &_FX($aname): \\"=r\\" ( &reg));  &return( &reg); });
	}' unless defined(&_R64F0);
	eval 'sub _WF0 () {( &fname,  &aname...)  &static  &__inline  &void  &fname( &void) {  &__asm  &__volatile("mcr\\t"  &_FX( &aname)); };}' unless defined(&_WF0);
	eval 'sub _WF1 () {( &fname,  &aname...)  &static  &__inline  &void  &fname( &uint32_t  &reg) {  &__asm  &__volatile("mcr\\t"  &_FX( &aname):: "r" ( &reg)); };}' unless defined(&_WF1);
	undef(&_FX) if defined(&_FX);
	undef(&_RF0) if defined(&_RF0);
	undef(&_WF0) if defined(&_WF0);
	undef(&_WF1) if defined(&_WF1);
	eval 'sub icache_sync {
	    my($va,$size) = @_;
    	    eval q({  &cpu_icache_sync_range($va, $size); });
	}' unless defined(&icache_sync);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub dcache_inv_poc {
	    my($va,$pa,$size) = @_;
    	    eval q({  &cpu_dcache_inv_range($va, $size); });
	}' unless defined(&dcache_inv_poc);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub dcache_inv_poc_dma {
	    my($va,$pa,$size) = @_;
    	    eval q({  &cpu_dcache_inv_range($va, $size); });
	}' unless defined(&dcache_inv_poc_dma);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub dcache_wb_poc {
	    my($va,$pa,$size) = @_;
    	    eval q({  &cpu_dcache_wb_range($va, $size); });
	}' unless defined(&dcache_wb_poc);
	eval 'sub dcache_wbinv_poc_all {
	    my($void) = @_;
    	    eval q({  &cpu_idcache_wbinv_all();  &cpu_l2cache_wbinv_all(); });
	}' unless defined(&dcache_wbinv_poc_all);
    }
}
1;
