require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MACHINE_CPU_V6_H)) {
    eval 'sub MACHINE_CPU_V6_H () {1;}' unless defined(&MACHINE_CPU_V6_H);
    unless(defined(&_KERNEL)) {
	die("Only\ include\ this\ file\ in\ the\ kernel");
    }
    require 'machine/atomic.ph';
    require 'machine/cpufunc.ph';
    require 'machine/cpuinfo.ph';
    require 'machine/sysreg.ph';
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) < 6) {
	die("Only\ include\ this\ file\ for\ ARMv6");
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) <= 6 && defined(&SMP)  && !defined(&KLD_MODULE)) {
	die("SMP\ option\ is\ not\ supported\ on\ ARMv6");
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) <= 6 && defined(&SMP_ON_UP)) {
	die("SMP_ON_UP\ option\ is\ only\ supported\ on\ ARMv7\+\ CPUs");
    }
    if(!defined(&SMP)  && defined(&SMP_ON_UP)) {
	die("SMP\ option\ must\ be\ defined\ for\ SMP_ON_UP\ option");
    }
    eval 'sub CPU_ASID_KERNEL () {0;}' unless defined(&CPU_ASID_KERNEL);
    if(defined(&SMP_ON_UP)) {
	eval 'sub ARM_SMP_UP {
	    my($smp_code, $up_code) = @_;
    	    eval q( &do {  &if ( ($cpuinfo->{mp_ext}) != 0) { $smp_code; }  &else { $up_code; } }  &while (0));
	}' unless defined(&ARM_SMP_UP);
    }
 elsif(defined(&SMP)  && (defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) > 6) {
	eval 'sub ARM_SMP_UP {
	    my($smp_code, $up_code) = @_;
    	    eval q( &do { $smp_code; }  &while (0));
	}' unless defined(&ARM_SMP_UP);
    } else {
	eval 'sub ARM_SMP_UP {
	    my($smp_code, $up_code) = @_;
    	    eval q( &do { $up_code; }  &while (0));
	}' unless defined(&ARM_SMP_UP);
    }
    if(defined(&DEV_PMU)) {
	require 'sys/pcpu.ph';
	eval 'sub PMU_OVSR_C () {0x80000000;}' unless defined(&PMU_OVSR_C);
    }
    eval 'sub sev () {
        eval q( &__asm  &__volatile(\\"sev\\" : : : \\"memory\\"));
    }' unless defined(&sev);
    eval 'sub wfe () {
        eval q( &__asm  &__volatile(\\"wfe\\" : : : \\"memory\\"));
    }' unless defined(&wfe);
    eval 'sub _FX () {( &s...)  &s;}' unless defined(&_FX);
    eval 'sub _RF0 () {( &fname,  &aname...)  &static  &__inline  &uint32_t  &fname( &void) {  &uint32_t  &reg;  &__asm  &__volatile("mrc\\t"  &_FX( &aname): "=r" ( &reg));  &return( &reg); };}' unless defined(&_RF0);
    eval 'sub _R64F0 {
        my($fname, $aname) = @_;
	    eval q( &static  &__inline  &uint64_t $fname( &void) {  &uint64_t  &reg;  &__asm  &__volatile(\\"mrrc\\\\t\\"  &_FX($aname): \\"=r\\" ( &reg));  &return( &reg); });
    }' unless defined(&_R64F0);
    eval 'sub _WF0 () {( &fname,  &aname...)  &static  &__inline  &void  &fname( &void) {  &__asm  &__volatile("mcr\\t"  &_FX( &aname)); };}' unless defined(&_WF0);
    eval 'sub _WF1 () {( &fname,  &aname...)  &static  &__inline  &void  &fname( &uint32_t  &reg) {  &__asm  &__volatile("mcr\\t"  &_FX( &aname):: "r" ( &reg)); };}' unless defined(&_WF1);
    eval 'sub _W64F1 () {( &fname,  &aname...)  &static  &__inline  &void  &fname( &uint64_t  &reg) {  &__asm  &__volatile("mcrr\\t"  &_FX( &aname):: "r" ( &reg)); };}' unless defined(&_W64F1);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7 && defined(&SMP)) {
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7 && defined(&SMP)) {
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7 && defined(&SMP)) {
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7 && defined(&SMP)) {
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7) {
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7 && defined(&SMP)) {
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7) {
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) == 6 && defined(&CPU_ARM1176)) {
    }
 elsif((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) > 6) {
    }
    undef(&_FX) if defined(&_FX);
    undef(&_RF0) if defined(&_RF0);
    undef(&_WF0) if defined(&_WF0);
    undef(&_WF1) if defined(&_WF1);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7 && defined(&SMP)) {
	eval 'sub tlb_flush_all {
	    my($void) = @_;
    	    eval q({  &dsb();  &ARM_SMP_UP(  &_CP15_TLBIALLIS(),  &_CP15_TLBIALL() );  &dsb(); });
	}' unless defined(&tlb_flush_all);
	eval 'sub tlb_flush_all_ng {
	    my($void) = @_;
    	    eval q({  &dsb();  &ARM_SMP_UP(  &_CP15_TLBIASIDIS( &CPU_ASID_KERNEL),  &_CP15_TLBIASID( &CPU_ASID_KERNEL) );  &dsb(); });
	}' unless defined(&tlb_flush_all_ng);
	eval 'sub tlb_flush {
	    my($va) = @_;
    	    eval q({  &KASSERT(($va &  &PAGE_MASK) == 0, (\\"%s: va %#x not aligned\\",  &__func__, $va));  &dsb();  &ARM_SMP_UP(  &_CP15_TLBIMVAAIS($va),  &_CP15_TLBIMVA($va |  &CPU_ASID_KERNEL) );  &dsb(); });
	}' unless defined(&tlb_flush);
	eval 'sub tlb_flush_range {
	    my($va,$size) = @_;
    	    eval q({  &vm_offset_t  &eva = $va + $size;  &KASSERT(($va &  &PAGE_MASK) == 0, (\\"%s: va %#x not aligned\\",  &__func__, $va));  &KASSERT(($size &  &PAGE_MASK) == 0, (\\"%s: size %#x not aligned\\",  &__func__, $size));  &dsb();  &ARM_SMP_UP( {  &for (; $va <  &eva; $va +=  &PAGE_SIZE)  &_CP15_TLBIMVAAIS($va); }, {  &for (; $va <  &eva; $va +=  &PAGE_SIZE)  &_CP15_TLBIMVA($va |  &CPU_ASID_KERNEL); } );  &dsb(); });
	}' unless defined(&tlb_flush_range);
    } else {
	eval 'sub tlb_flush_all () {
	    eval q( &tlb_flush_all_local());
	}' unless defined(&tlb_flush_all);
	eval 'sub tlb_flush_all_ng () {
	    eval q( &tlb_flush_all_ng_local());
	}' unless defined(&tlb_flush_all_ng);
	eval 'sub tlb_flush {
	    my($va) = @_;
    	    eval q( &tlb_flush_local($va));
	}' unless defined(&tlb_flush);
	eval 'sub tlb_flush_range {
	    my($va, $size) = @_;
    	    eval q( &tlb_flush_range_local($va, $size));
	}' unless defined(&tlb_flush_range);
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7) {
    } else {
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7) {
    } else {
    }
    eval 'sub cp15_ats1cpw_check {
        my($addr) = @_;
	    eval q({  &cp15_ats1cpw_set($addr);  &isb(); ( &cp15_par_get() & 0x1 ?  &EFAULT : 0); });
    }' unless defined(&cp15_ats1cpw_check);
    eval 'sub cp15_ats1cur_check {
        my($addr) = @_;
	    eval q({  &cp15_ats1cur_set($addr);  &isb(); ( &cp15_par_get() & 0x1 ?  &EFAULT : 0); });
    }' unless defined(&cp15_ats1cur_check);
    eval 'sub cp15_ats1cuw_check {
        my($addr) = @_;
	    eval q({  &cp15_ats1cuw_set($addr);  &isb(); ( &cp15_par_get() & 0x1 ?  &EFAULT : 0); });
    }' unless defined(&cp15_ats1cuw_check);
}
1;
