require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MACHINE_CPU_H)) {
    eval 'sub MACHINE_CPU_H () {1;}' unless defined(&MACHINE_CPU_H);
    require 'machine/armreg.ph';
    require 'machine/frame.ph';
    if(defined(&_KERNEL)) {
	if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	    require 'machine/cpu-v6.ph';
	} else {
	    require 'machine/cpu-v4.ph';
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub get_cyclecount {
	    my($void) = @_;
    	    eval q({  &cp15_pmccntr_get();  &else \'struct bintime\'  &bt;  &binuptime( &bt); (( &uint64_t) ($bt->{sec}) << 56|  ($bt->{frac}) >> 8);  &endif });
	}' unless defined(&get_cyclecount);
    }
    eval 'sub TRAPF_USERMODE {
        my($frame) = @_;
	    eval q((( ($frame->{tf_spsr}) &  &PSR_MODE) ==  &PSR_USR32_MODE));
    }' unless defined(&TRAPF_USERMODE);
    eval 'sub TRAPF_PC {
        my($tfp) = @_;
	    eval q((($tfp)-> &tf_pc));
    }' unless defined(&TRAPF_PC);
    eval 'sub cpu_getstack {
        my($td) = @_;
	    eval q((($td)-> ($td_frame->{tf_usr_sp})));
    }' unless defined(&cpu_getstack);
    eval 'sub cpu_setstack {
        my($td, $sp) = @_;
	    eval q((($td)-> ($td_frame->{tf_usr_sp}) = ($sp)));
    }' unless defined(&cpu_setstack);
    eval 'sub cpu_spinwait () {
        eval q();
    }' unless defined(&cpu_spinwait);
    eval 'sub cpu_lock_delay () {
        eval q( &DELAY(1));
    }' unless defined(&cpu_lock_delay);
    eval 'sub ARM_NVEC () {8;}' unless defined(&ARM_NVEC);
    eval 'sub ARM_VEC_ALL () {0xffffffff;}' unless defined(&ARM_VEC_ALL);
}
1;
