require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_DB_MACHDEP_H_)) {
    eval 'sub _MACHINE_DB_MACHDEP_H_ () {1;}' unless defined(&_MACHINE_DB_MACHDEP_H_);
    require 'machine/frame.ph';
    require 'machine/trap.ph';
    require 'machine/armreg.ph';
    eval 'sub T_BREAKPOINT () {(1);}' unless defined(&T_BREAKPOINT);
    eval 'sub T_WATCHPOINT () {(2);}' unless defined(&T_WATCHPOINT);
    eval 'sub PC_REGS () {
        eval q((( &db_addr_t) ($kdb_thrctx->{pcb_regs}->{sf_pc})));
    }' unless defined(&PC_REGS);
    eval 'sub BKPT_INST () {( &KERNEL_BREAKPOINT);}' unless defined(&BKPT_INST);
    eval 'sub BKPT_SIZE () {( &INSN_SIZE);}' unless defined(&BKPT_SIZE);
    eval 'sub BKPT_SET {
        my($inst) = @_;
	    eval q(( &BKPT_INST));
    }' unless defined(&BKPT_SET);
    eval 'sub BKPT_SKIP () { &do {  ($kdb_frame->{tf_pc}) +=  &BKPT_SIZE; }  &while (0);}' unless defined(&BKPT_SKIP);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	eval 'sub db_clear_single_step () { &kdb_cpu_clear_singlestep;}' unless defined(&db_clear_single_step);
	eval 'sub db_set_single_step () { &kdb_cpu_set_singlestep;}' unless defined(&db_set_single_step);
	eval 'sub db_pc_is_singlestep () { &kdb_cpu_pc_is_singlestep;}' unless defined(&db_pc_is_singlestep);
    } else {
	eval 'sub SOFTWARE_SSTEP () {1;}' unless defined(&SOFTWARE_SSTEP);
    }
    eval 'sub IS_BREAKPOINT_TRAP {
        my($type, $code) = @_;
	    eval q(($type ==  &T_BREAKPOINT));
    }' unless defined(&IS_BREAKPOINT_TRAP);
    eval 'sub IS_WATCHPOINT_TRAP {
        my($type, $code) = @_;
	    eval q(($type ==  &T_WATCHPOINT));
    }' unless defined(&IS_WATCHPOINT_TRAP);
    eval 'sub inst_trap_return {
        my($ins) = @_;
	    eval q((0));
    }' unless defined(&inst_trap_return);
    eval 'sub inst_return {
        my($ins) = @_;
	    eval q(((($ins) & 0xe108000) == 0x8108000 || (($ins) & 0xff0fff0) == 0x1a0f000 || (($ins) & 0xffffff0) == 0x12fff10));
    }' unless defined(&inst_return);
    eval 'sub inst_call {
        my($ins) = @_;
	    eval q(((($ins) & 0xf000000) == 0xb000000));
    }' unless defined(&inst_call);
    eval 'sub inst_branch {
        my($ins) = @_;
	    eval q(((($ins) & 0xf000000) == 0xa000000 || (($ins) & 0xfdffff0) == 0x79ff100 || (($ins) & 0xcd0f000) == 0x490f000 || (($ins) & 0xffffff0) == 0x12fff30 || (($ins) & 0xde0f000) == 0x80f000));
    }' unless defined(&inst_branch);
    eval 'sub inst_load {
        my($ins) = @_;
	    eval q((0));
    }' unless defined(&inst_load);
    eval 'sub inst_store {
        my($ins) = @_;
	    eval q((0));
    }' unless defined(&inst_store);
    eval 'sub next_instr_address {
        my($pc, $bd) = @_;
	    eval q((($bd) ? ($pc) : (($pc) +  &INSN_SIZE)));
    }' unless defined(&next_instr_address);
    eval 'sub DB_ELFSIZE () {32;}' unless defined(&DB_ELFSIZE);
}
1;
