require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ELF_H_)) {
    eval 'sub _MACHINE_ELF_H_ () {1;}' unless defined(&_MACHINE_ELF_H_);
    require 'sys/elf32.ph';
    eval 'sub __ELF_WORD_SIZE () {32;}' unless defined(&__ELF_WORD_SIZE);
    require 'sys/elf_generic.ph';
    eval 'sub ELF_ARCH () { &EM_ARM;}' unless defined(&ELF_ARCH);
    eval 'sub ELF_MACHINE_OK {
        my($x) = @_;
	    eval q((($x) ==  &EM_ARM));
    }' unless defined(&ELF_MACHINE_OK);
    eval 'sub AT_NULL () {0;}' unless defined(&AT_NULL);
    eval 'sub AT_IGNORE () {1;}' unless defined(&AT_IGNORE);
    eval 'sub AT_EXECFD () {2;}' unless defined(&AT_EXECFD);
    eval 'sub AT_PHDR () {3;}' unless defined(&AT_PHDR);
    eval 'sub AT_PHENT () {4;}' unless defined(&AT_PHENT);
    eval 'sub AT_PHNUM () {5;}' unless defined(&AT_PHNUM);
    eval 'sub AT_PAGESZ () {6;}' unless defined(&AT_PAGESZ);
    eval 'sub AT_BASE () {7;}' unless defined(&AT_BASE);
    eval 'sub AT_FLAGS () {8;}' unless defined(&AT_FLAGS);
    eval 'sub AT_ENTRY () {9;}' unless defined(&AT_ENTRY);
    eval 'sub AT_NOTELF () {10;}' unless defined(&AT_NOTELF);
    eval 'sub AT_UID () {11;}' unless defined(&AT_UID);
    eval 'sub AT_EUID () {12;}' unless defined(&AT_EUID);
    eval 'sub AT_GID () {13;}' unless defined(&AT_GID);
    eval 'sub AT_EGID () {14;}' unless defined(&AT_EGID);
    eval 'sub AT_EXECPATH () {15;}' unless defined(&AT_EXECPATH);
    eval 'sub AT_CANARY () {16;}' unless defined(&AT_CANARY);
    eval 'sub AT_CANARYLEN () {17;}' unless defined(&AT_CANARYLEN);
    eval 'sub AT_OSRELDATE () {18;}' unless defined(&AT_OSRELDATE);
    eval 'sub AT_NCPUS () {19;}' unless defined(&AT_NCPUS);
    eval 'sub AT_PAGESIZES () {20;}' unless defined(&AT_PAGESIZES);
    eval 'sub AT_PAGESIZESLEN () {21;}' unless defined(&AT_PAGESIZESLEN);
    eval 'sub AT_TIMEKEEP () {22;}' unless defined(&AT_TIMEKEEP);
    eval 'sub AT_STACKPROT () {23;}' unless defined(&AT_STACKPROT);
    eval 'sub AT_EHDRFLAGS () {24;}' unless defined(&AT_EHDRFLAGS);
    eval 'sub AT_HWCAP () {25;}' unless defined(&AT_HWCAP);
    eval 'sub AT_HWCAP2 () {26;}' unless defined(&AT_HWCAP2);
    eval 'sub AT_COUNT () {27;}' unless defined(&AT_COUNT);
    eval 'sub R_ARM_COUNT () {33;}' unless defined(&R_ARM_COUNT);
    eval 'sub ELF_TARG_CLASS () { &ELFCLASS32;}' unless defined(&ELF_TARG_CLASS);
    if(defined(&__ARMEB__)) {
	eval 'sub ELF_TARG_DATA () { &ELFDATA2MSB;}' unless defined(&ELF_TARG_DATA);
    } else {
	eval 'sub ELF_TARG_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_TARG_DATA);
    }
    eval 'sub ELF_TARG_MACH () { &EM_ARM;}' unless defined(&ELF_TARG_MACH);
    eval 'sub ELF_TARG_VER () {1;}' unless defined(&ELF_TARG_VER);
    eval 'sub EF_ARM_EABI_VERSION {
        my($x) = @_;
	    eval q(((($x) &  &EF_ARM_EABIMASK) >> 24));
    }' unless defined(&EF_ARM_EABI_VERSION);
    eval 'sub EF_ARM_EABI_VERSION_UNKNOWN () {0;}' unless defined(&EF_ARM_EABI_VERSION_UNKNOWN);
    eval 'sub EF_ARM_EABI_FREEBSD_MIN () {4;}' unless defined(&EF_ARM_EABI_FREEBSD_MIN);
    eval 'sub MAGIC_TRAMP_NUMBER () {0x5c000003;}' unless defined(&MAGIC_TRAMP_NUMBER);
    eval 'sub ET_DYN_LOAD_ADDR () {0x500000;}' unless defined(&ET_DYN_LOAD_ADDR);
    eval 'sub HWCAP_SWP () {0x1;}' unless defined(&HWCAP_SWP);
    eval 'sub HWCAP_HALF () {0x2;}' unless defined(&HWCAP_HALF);
    eval 'sub HWCAP_THUMB () {0x4;}' unless defined(&HWCAP_THUMB);
    eval 'sub HWCAP_26BIT () {0x8;}' unless defined(&HWCAP_26BIT);
    eval 'sub HWCAP_FAST_MULT () {0x10;}' unless defined(&HWCAP_FAST_MULT);
    eval 'sub HWCAP_FPA () {0x20;}' unless defined(&HWCAP_FPA);
    eval 'sub HWCAP_VFP () {0x40;}' unless defined(&HWCAP_VFP);
    eval 'sub HWCAP_EDSP () {0x80;}' unless defined(&HWCAP_EDSP);
    eval 'sub HWCAP_JAVA () {0x100;}' unless defined(&HWCAP_JAVA);
    eval 'sub HWCAP_IWMMXT () {0x200;}' unless defined(&HWCAP_IWMMXT);
    eval 'sub HWCAP_CRUNCH () {0x400;}' unless defined(&HWCAP_CRUNCH);
    eval 'sub HWCAP_THUMBEE () {0x800;}' unless defined(&HWCAP_THUMBEE);
    eval 'sub HWCAP_NEON () {0x1000;}' unless defined(&HWCAP_NEON);
    eval 'sub HWCAP_VFPv3 () {0x2000;}' unless defined(&HWCAP_VFPv3);
    eval 'sub HWCAP_VFPv3D16 () {0x4000;}' unless defined(&HWCAP_VFPv3D16);
    eval 'sub HWCAP_TLS () {0x8000;}' unless defined(&HWCAP_TLS);
    eval 'sub HWCAP_VFPv4 () {0x10000;}' unless defined(&HWCAP_VFPv4);
    eval 'sub HWCAP_IDIVA () {0x20000;}' unless defined(&HWCAP_IDIVA);
    eval 'sub HWCAP_IDIVT () {0x40000;}' unless defined(&HWCAP_IDIVT);
    eval 'sub HWCAP_VFPD32 () {0x80000;}' unless defined(&HWCAP_VFPD32);
    eval 'sub HWCAP_IDIV () {( &HWCAP_IDIVA |  &HWCAP_IDIVT);}' unless defined(&HWCAP_IDIV);
    eval 'sub HWCAP_LPAE () {0x100000;}' unless defined(&HWCAP_LPAE);
    eval 'sub HWCAP_EVTSTRM () {0x200000;}' unless defined(&HWCAP_EVTSTRM);
    eval 'sub HWCAP2_AES () {0x1;}' unless defined(&HWCAP2_AES);
    eval 'sub HWCAP2_PMULL () {0x2;}' unless defined(&HWCAP2_PMULL);
    eval 'sub HWCAP2_SHA1 () {0x4;}' unless defined(&HWCAP2_SHA1);
    eval 'sub HWCAP2_SHA2 () {0x8;}' unless defined(&HWCAP2_SHA2);
    eval 'sub HWCAP2_CRC32 () {0x10;}' unless defined(&HWCAP2_CRC32);
}
1;
