require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ENDIAN_H_)) {
    eval 'sub _ENDIAN_H_ () {1;}' unless defined(&_ENDIAN_H_);
    require 'sys/_types.ph';
    eval 'sub _LITTLE_ENDIAN () {1234;}' unless defined(&_LITTLE_ENDIAN);
    eval 'sub _BIG_ENDIAN () {4321;}' unless defined(&_BIG_ENDIAN);
    eval 'sub _PDP_ENDIAN () {3412;}' unless defined(&_PDP_ENDIAN);
    if(defined(&__ARMEB__)) {
	eval 'sub _BYTE_ORDER () { &_BIG_ENDIAN;}' unless defined(&_BYTE_ORDER);
    } else {
	eval 'sub _BYTE_ORDER () { &_LITTLE_ENDIAN;}' unless defined(&_BYTE_ORDER);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub LITTLE_ENDIAN () { &_LITTLE_ENDIAN;}' unless defined(&LITTLE_ENDIAN);
	eval 'sub BIG_ENDIAN () { &_BIG_ENDIAN;}' unless defined(&BIG_ENDIAN);
	eval 'sub PDP_ENDIAN () { &_PDP_ENDIAN;}' unless defined(&PDP_ENDIAN);
	eval 'sub BYTE_ORDER () { &_BYTE_ORDER;}' unless defined(&BYTE_ORDER);
    }
    if(defined(&__ARMEB__)) {
	eval 'sub _QUAD_HIGHWORD () {0;}' unless defined(&_QUAD_HIGHWORD);
	eval 'sub _QUAD_LOWWORD () {1;}' unless defined(&_QUAD_LOWWORD);
	eval 'sub __ntohl {
	    my($x) = @_;
    	    eval q((( &__uint32_t)($x)));
	}' unless defined(&__ntohl);
	eval 'sub __ntohs {
	    my($x) = @_;
    	    eval q((( &__uint16_t)($x)));
	}' unless defined(&__ntohs);
	eval 'sub __htonl {
	    my($x) = @_;
    	    eval q((( &__uint32_t)($x)));
	}' unless defined(&__htonl);
	eval 'sub __htons {
	    my($x) = @_;
    	    eval q((( &__uint16_t)($x)));
	}' unless defined(&__htons);
    } else {
	eval 'sub _QUAD_HIGHWORD () {1;}' unless defined(&_QUAD_HIGHWORD);
	eval 'sub _QUAD_LOWWORD () {0;}' unless defined(&_QUAD_LOWWORD);
	eval 'sub __ntohl {
	    my($x) = @_;
    	    eval q(( &__bswap32($x)));
	}' unless defined(&__ntohl);
	eval 'sub __ntohs {
	    my($x) = @_;
    	    eval q(( &__bswap16($x)));
	}' unless defined(&__ntohs);
	eval 'sub __htonl {
	    my($x) = @_;
    	    eval q(( &__bswap32($x)));
	}' unless defined(&__htonl);
	eval 'sub __htons {
	    my($x) = @_;
    	    eval q(( &__bswap16($x)));
	}' unless defined(&__htons);
    }
    eval 'sub __bswap64 {
        my($_x) = @_;
	    eval q({ (($_x >> 56) | (($_x >> 40) & 0xff00) | (($_x >> 24) & 0xff0000) | (($_x >> 8) & 0xff000000) | (($_x << 8) & (( &__uint64_t)0xff << 32)) | (($_x << 24) & (( &__uint64_t)0xff << 40)) | (($_x << 40) & (( &__uint64_t)0xff << 48)) | (($_x << 56))); });
    }' unless defined(&__bswap64);
    eval 'sub __bswap32_var {
        my($v) = @_;
	    eval q({  &__uint32_t  &t1;  &__asm  &__volatile(\\"eor %1, %0, %0, ror #16\\\\n\\" \\"bic %1, %1, #0x00ff0000\\\\n\\" \\"mov %0, %0, ror #8\\\\n\\" \\"eor %0, %0, %1, lsr #8\\\\n\\" : \\"+r\\" ($v), \\"=r\\" ( &t1)); ($v); });
    }' unless defined(&__bswap32_var);
    eval 'sub __bswap16_var {
        my($v) = @_;
	    eval q({  &__uint32_t  &ret = $v & 0xffff;  &__asm  &__volatile( \\"mov    %0, %0, ror #8\\\\n\\" \\"orr    %0, %0, %0, lsr #16\\\\n\\" \\"bic    %0, %0, %0, lsl #16\\" : \\"+r\\" ( &ret)); (( &__uint16_t) &ret); });
    }' unless defined(&__bswap16_var);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __bswap32_constant {
	    my($x) = @_;
    	    eval q((((($x) & 0xff000000) >> 24) | ((($x) & 0xff0000) >> 8) | ((($x) & 0xff00) << 8) | ((($x) & 0xff) << 24)));
	}' unless defined(&__bswap32_constant);
	eval 'sub __bswap16_constant {
	    my($x) = @_;
    	    eval q((((($x) & 0xff00) >> 8) | ((($x) & 0xff) << 8)));
	}' unless defined(&__bswap16_constant);
	eval 'sub __bswap16 {
	    my($x) = @_;
    	    eval q((( &__uint16_t)( &__builtin_constant_p($x) ?  &__bswap16_constant($x) :  &__bswap16_var($x))));
	}' unless defined(&__bswap16);
	eval 'sub __bswap32 {
	    my($x) = @_;
    	    eval q((( &__uint32_t)( &__builtin_constant_p($x) ?  &__bswap32_constant($x) :  &__bswap32_var($x))));
	}' unless defined(&__bswap32);
    } else {
	eval 'sub __bswap16 {
	    my($x) = @_;
    	    eval q( &__bswap16_var($x));
	}' unless defined(&__bswap16);
	eval 'sub __bswap32 {
	    my($x) = @_;
    	    eval q( &__bswap32_var($x));
	}' unless defined(&__bswap32);
    }
}
1;
