require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ARM_INCLUDE_PARAM_H_)) {
    eval 'sub _ARM_INCLUDE_PARAM_H_ () {1;}' unless defined(&_ARM_INCLUDE_PARAM_H_);
    require 'machine/_align.ph';
    eval 'sub STACKALIGNBYTES () {(8- 1);}' unless defined(&STACKALIGNBYTES);
    eval 'sub STACKALIGN {
        my($p) = @_;
	    eval q((($p) & ~ &STACKALIGNBYTES));
    }' unless defined(&STACKALIGN);
    eval 'sub __PCI_REROUTE_INTERRUPT () {1;}' unless defined(&__PCI_REROUTE_INTERRUPT);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7) {
	eval 'sub _V_SUFFIX () {"v7";}' unless defined(&_V_SUFFIX);
    }
 elsif((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	eval 'sub _V_SUFFIX () {"v6";}' unless defined(&_V_SUFFIX);
    } else {
	eval 'sub _V_SUFFIX () {"";}' unless defined(&_V_SUFFIX);
    }
    if(defined(&__ARM_BIG_ENDIAN)) {
	eval 'sub _EB_SUFFIX () {"eb";}' unless defined(&_EB_SUFFIX);
    } else {
	eval 'sub _EB_SUFFIX () {"";}' unless defined(&_EB_SUFFIX);
    }
    unless(defined(&MACHINE)) {
	eval 'sub MACHINE () {"arm";}' unless defined(&MACHINE);
    }
    unless(defined(&MACHINE_ARCH)) {
	eval 'sub MACHINE_ARCH () {"arm"  &_V_SUFFIX  &_EB_SUFFIX;}' unless defined(&MACHINE_ARCH);
    }
    if(defined(&SMP) || defined(&KLD_MODULE)) {
	unless(defined(&MAXCPU)) {
	    eval 'sub MAXCPU () {4;}' unless defined(&MAXCPU);
	}
    } else {
	eval 'sub MAXCPU () {1;}' unless defined(&MAXCPU);
    }
    unless(defined(&MAXMEMDOM)) {
	eval 'sub MAXMEMDOM () {1;}' unless defined(&MAXMEMDOM);
    }
    eval 'sub ALIGNBYTES () { &_ALIGNBYTES;}' unless defined(&ALIGNBYTES);
    eval 'sub ALIGN {
        my($p) = @_;
	    eval q( &_ALIGN($p));
    }' unless defined(&ALIGN);
    eval 'sub ALIGNED_POINTER {
        my($p, $t) = @_;
	    eval q((((($p)) & ($sizeof{$t}-1)) == 0));
    }' unless defined(&ALIGNED_POINTER);
    eval 'sub CACHE_LINE_SHIFT () {6;}' unless defined(&CACHE_LINE_SHIFT);
    eval 'sub CACHE_LINE_SIZE () {(1<<  &CACHE_LINE_SHIFT);}' unless defined(&CACHE_LINE_SIZE);
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1<<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {( &PAGE_SIZE - 1);}' unless defined(&PAGE_MASK);
    eval 'sub PDR_SHIFT () {20;}' unless defined(&PDR_SHIFT);
    eval 'sub NBPDR () {(1<<  &PDR_SHIFT);}' unless defined(&NBPDR);
    eval 'sub PDRMASK () {( &NBPDR - 1);}' unless defined(&PDRMASK);
    eval 'sub NPDEPG () {(1<< (32-  &PDR_SHIFT));}' unless defined(&NPDEPG);
    eval 'sub MAXPAGESIZES () {2;}' unless defined(&MAXPAGESIZES);
    unless(defined(&KSTACK_PAGES)) {
	eval 'sub KSTACK_PAGES () {4;}' unless defined(&KSTACK_PAGES);
    }
    unless(defined(&FPCONTEXTSIZE)) {
	eval 'sub FPCONTEXTSIZE () {(0x100);}' unless defined(&FPCONTEXTSIZE);
    }
    unless(defined(&KSTACK_GUARD_PAGES)) {
	eval 'sub KSTACK_GUARD_PAGES () {1;}' unless defined(&KSTACK_GUARD_PAGES);
    }
    eval 'sub USPACE_SVC_STACK_TOP () {( &kstack_pages *  &PAGE_SIZE);}' unless defined(&USPACE_SVC_STACK_TOP);
    eval 'sub trunc_page {
        my($x) = @_;
	    eval q((($x) & ~ &PAGE_MASK));
    }' unless defined(&trunc_page);
    eval 'sub round_page {
        my($x) = @_;
	    eval q(((($x) +  &PAGE_MASK) & ~ &PAGE_MASK));
    }' unless defined(&round_page);
    eval 'sub trunc_1mpage {
        my($x) = @_;
	    eval q((($x) & ~ &PDRMASK));
    }' unless defined(&trunc_1mpage);
    eval 'sub round_1mpage {
        my($x) = @_;
	    eval q((((($x)) +  &PDRMASK) & ~ &PDRMASK));
    }' unless defined(&round_1mpage);
    eval 'sub atop {
        my($x) = @_;
	    eval q((($x) >>  &PAGE_SHIFT));
    }' unless defined(&atop);
    eval 'sub ptoa {
        my($x) = @_;
	    eval q((($x) <<  &PAGE_SHIFT));
    }' unless defined(&ptoa);
    eval 'sub arm32_btop {
        my($x) = @_;
	    eval q((($x) >>  &PAGE_SHIFT));
    }' unless defined(&arm32_btop);
    eval 'sub arm32_ptob {
        my($x) = @_;
	    eval q((($x) <<  &PAGE_SHIFT));
    }' unless defined(&arm32_ptob);
    eval 'sub pgtok {
        my($x) = @_;
	    eval q((($x) * ( &PAGE_SIZE / 1024)));
    }' unless defined(&pgtok);
}
1;
