require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PCPU_H_)) {
    eval 'sub _MACHINE_PCPU_H_ () {1;}' unless defined(&_MACHINE_PCPU_H_);
    if(defined(&_KERNEL)) {
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
	eval 'sub ALT_STACK_SIZE () {128;}' unless defined(&ALT_STACK_SIZE);
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	eval 'sub PCPU_BP_HARDEN_KIND_NONE () {0;}' unless defined(&PCPU_BP_HARDEN_KIND_NONE);
	eval 'sub PCPU_BP_HARDEN_KIND_BPIALL () {1;}' unless defined(&PCPU_BP_HARDEN_KIND_BPIALL);
	eval 'sub PCPU_BP_HARDEN_KIND_ICIALLU () {2;}' unless defined(&PCPU_BP_HARDEN_KIND_ICIALLU);
	eval 'sub PCPU_MD_FIELDS () {\'unsigned int pc_vfpsid\'; \'unsigned int pc_vfpmvfr0\'; \'unsigned int pc_vfpmvfr1\'; \'struct pmap\' * &pc_curpmap; \'struct mtx\'  &pc_cmap_lock;  &void * &pc_cmap1_pte2p;  &void * &pc_cmap2_pte2p; \'caddr_t\'  &pc_cmap1_addr; \'caddr_t\'  &pc_cmap2_addr;  &vm_offset_t  &pc_qmap_addr;  &void * &pc_qmap_pte2p; \'unsigned int pc_dbreg\'[32]; \'int\'  &pc_dbreg_cmd; \'int\'  &pc_bp_harden_kind;  &uint32_t  &pc_original_actlr;  &uint64_t  &pc_clock;  &uint32_t  &pc_mpidr; \'char\'  $__pad[135];}' unless defined(&PCPU_MD_FIELDS);
    } else {
	eval 'sub PCPU_MD_FIELDS () {\'char\'  $__pad[93];}' unless defined(&PCPU_MD_FIELDS);
    }
    if(defined(&_KERNEL)) {
	eval 'sub PC_DBREG_CMD_NONE () {0;}' unless defined(&PC_DBREG_CMD_NONE);
	eval 'sub PC_DBREG_CMD_LOAD () {1;}' unless defined(&PC_DBREG_CMD_LOAD);
	if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	    eval 'sub CPU_MASK () {(0xf);}' unless defined(&CPU_MASK);
	    unless(defined(&SMP)) {
		eval 'sub get_pcpu () {
		    eval q(( &pcpup));
		}' unless defined(&get_pcpu);
	    } else {
		eval 'sub get_pcpu () {
		    eval q( &__extension__ ({ \'int\'  &id;  &__asm  &__volatile(\\"mrc p15, 0, %0, c0, c0, 5\\" : \\"=r\\" ( &id)); ( &pcpup + ( &id &  &CPU_MASK)); }));
		}' unless defined(&get_pcpu);
	    }
	    eval 'sub get_curthread {
	        my($void) = @_;
    		eval q({ $void * &ret;  &__asm  &__volatile(\\"mrc p15, 0, %0, c13, c0, 4\\" : \\"=r\\" ( &ret)); ( &ret); });
	    }' unless defined(&get_curthread);
	    eval 'sub set_curthread {
	        my($td) = @_;
    		eval q({  &__asm  &__volatile(\\"mcr p15, 0, %0, c13, c0, 4\\" : : \\"r\\" ($td)); });
	    }' unless defined(&set_curthread);
	    eval 'sub get_tls {
	        my($void) = @_;
    		eval q({ $void * &tls;  &__asm  &__volatile(\\"mrc p15, 0, %0, c13, c0, 2\\" : \\"=r\\" ( &tls)); ( &tls); });
	    }' unless defined(&get_tls);
	    eval 'sub set_tls {
	        my($tls) = @_;
    		eval q({  &__asm  &__volatile( \\"mcr p15, 0, %0, c13, c0, 2\\\\n\\" \\"mcr p15, 0, %0, c13, c0, 3\\\\n\\" : : \\"r\\" ($tls)); });
	    }' unless defined(&set_tls);
	    eval 'sub curthread () { &get_curthread();}' unless defined(&curthread);
	} else {
	    eval 'sub get_pcpu () {
	        eval q( &pcpup);
	    }' unless defined(&get_pcpu);
	}
	eval 'sub PCPU_GET {
	    my($member) = @_;
    	    eval q(( &get_pcpu()-> &pc_  $member));
	}' unless defined(&PCPU_GET);
	eval 'sub PCPU_ADD {
	    my($member, $value) = @_;
    	    eval q(( &get_pcpu()-> &pc_  $member += ($value)));
	}' unless defined(&PCPU_ADD);
	eval 'sub PCPU_INC {
	    my($member) = @_;
    	    eval q( &PCPU_ADD($member, 1));
	}' unless defined(&PCPU_INC);
	eval 'sub PCPU_PTR {
	    my($member) = @_;
    	    eval q(( &get_pcpu()-> &pc_  $member));
	}' unless defined(&PCPU_PTR);
	eval 'sub PCPU_SET {
	    my($member,$value) = @_;
    	    eval q(( &get_pcpu()-> &pc_  $member = ($value)));
	}' unless defined(&PCPU_SET);
    }
}
1;
