require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PMAP_V4_H_)) {
    eval 'sub _MACHINE_PMAP_V4_H_ () {1;}' unless defined(&_MACHINE_PMAP_V4_H_);
    require 'machine/pte-v4.ph';
    eval 'sub PTE_NOCACHE () {1;}' unless defined(&PTE_NOCACHE);
    eval 'sub PTE_CACHE () {2;}' unless defined(&PTE_CACHE);
    eval 'sub PTE_DEVICE () { &PTE_NOCACHE;}' unless defined(&PTE_DEVICE);
    eval 'sub PTE_PAGETABLE () {3;}' unless defined(&PTE_PAGETABLE);
    eval("sub STRONG_ORD () { 0; }") unless defined(&STRONG_ORD);
    eval("sub DEVICE_NOSHARE () { 1; }") unless defined(&DEVICE_NOSHARE);
    eval("sub DEVICE_SHARE () { 2; }") unless defined(&DEVICE_SHARE);
    eval("sub NRML_NOCACHE () { 3; }") unless defined(&NRML_NOCACHE);
    eval("sub NRML_IWT_OWT () { 4; }") unless defined(&NRML_IWT_OWT);
    eval("sub NRML_IWB_OWB () { 5; }") unless defined(&NRML_IWB_OWB);
    eval("sub NRML_IWBA_OWBA () { 6; }") unless defined(&NRML_IWBA_OWBA);
    unless(defined(&LOCORE)) {
	require 'sys/queue.ph';
	require 'sys/_cpuset.ph';
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
	eval 'sub PDESIZE () {$sizeof{ &pd_entry_t};}' unless defined(&PDESIZE);
	eval 'sub PTESIZE () {$sizeof{ &pt_entry_t};}' unless defined(&PTESIZE);
	eval 'sub pmap_page_get_memattr {
	    my($m) = @_;
    	    eval q((($m)-> ($md->{pv_memattr})));
	}' unless defined(&pmap_page_get_memattr);
	eval 'sub pmap_page_is_mapped {
	    my($m) = @_;
    	    eval q((! &TAILQ_EMPTY(($m)-> ($md->{pv_list}))));
	}' unless defined(&pmap_page_is_mapped);
	eval 'sub L2_BUCKET_LOG2 () {4;}' unless defined(&L2_BUCKET_LOG2);
	eval 'sub L2_BUCKET_SIZE () {(1<<  &L2_BUCKET_LOG2);}' unless defined(&L2_BUCKET_SIZE);
	eval 'sub L2_LOG2 () {((32-  &L1_S_SHIFT) -  &L2_BUCKET_LOG2);}' unless defined(&L2_LOG2);
	eval 'sub L2_SIZE () {(1<<  &L2_LOG2);}' unless defined(&L2_SIZE);
	if(defined(&_KERNEL)) {
	    eval 'sub kernel_pmap () {( &kernel_pmap_store);}' unless defined(&kernel_pmap);
	    eval 'sub PMAP_ASSERT_LOCKED {
	        my($pmap) = @_;
    		eval q( &mtx_assert(($pmap)-> &pm_mtx,  &MA_OWNED));
	    }' unless defined(&PMAP_ASSERT_LOCKED);
	    eval 'sub PMAP_LOCK {
	        my($pmap) = @_;
    		eval q( &mtx_lock(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_LOCK);
	    eval 'sub PMAP_LOCK_DESTROY {
	        my($pmap) = @_;
    		eval q( &mtx_destroy(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_LOCK_DESTROY);
	    eval 'sub PMAP_LOCK_INIT {
	        my($pmap) = @_;
    		eval q( &mtx_init(($pmap)-> &pm_mtx, \\"pmap\\",  &NULL,  &MTX_DEF |  &MTX_DUPOK));
	    }' unless defined(&PMAP_LOCK_INIT);
	    eval 'sub PMAP_OWNED {
	        my($pmap) = @_;
    		eval q( &mtx_owned(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_OWNED);
	    eval 'sub PMAP_MTX {
	        my($pmap) = @_;
    		eval q((($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_MTX);
	    eval 'sub PMAP_TRYLOCK {
	        my($pmap) = @_;
    		eval q( &mtx_trylock(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_TRYLOCK);
	    eval 'sub PMAP_UNLOCK {
	        my($pmap) = @_;
    		eval q( &mtx_unlock(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_UNLOCK);
	}
	eval 'sub _NPCM () {8;}' unless defined(&_NPCM);
	eval 'sub _NPCPV () {252;}' unless defined(&_NPCPV);
	if(defined(&_KERNEL)) {
	    eval 'sub PMAP_DOMAINS () {15;}' unless defined(&PMAP_DOMAINS);
	    eval 'sub PMAP_DOMAIN_KERNEL () {0;}' unless defined(&PMAP_DOMAIN_KERNEL);
	    eval 'sub L1_S_CACHE_MASK () {( &L1_S_B| &L1_S_C);}' unless defined(&L1_S_CACHE_MASK);
	    eval 'sub L2_L_CACHE_MASK () {( &L2_B| &L2_C);}' unless defined(&L2_L_CACHE_MASK);
	    eval 'sub L2_S_PROT_U () {( &L2_AP( &AP_U));}' unless defined(&L2_S_PROT_U);
	    eval 'sub L2_S_PROT_W () {( &L2_AP( &AP_W));}' unless defined(&L2_S_PROT_W);
	    eval 'sub L2_S_PROT_MASK () {( &L2_S_PROT_U| &L2_S_PROT_W);}' unless defined(&L2_S_PROT_MASK);
	    eval 'sub L2_S_CACHE_MASK () {( &L2_B| &L2_C);}' unless defined(&L2_S_CACHE_MASK);
	    eval 'sub L1_S_PROTO () {( &L1_TYPE_S |  &L1_S_IMP);}' unless defined(&L1_S_PROTO);
	    eval 'sub L1_C_PROTO () {( &L1_TYPE_C |  &L1_C_IMP2);}' unless defined(&L1_C_PROTO);
	    eval 'sub L2_L_PROTO () {( &L2_TYPE_L);}' unless defined(&L2_L_PROTO);
	    eval 'sub L2_S_PROTO () {( &L2_TYPE_S);}' unless defined(&L2_S_PROTO);
	    eval 'sub L2_AP {
	        my($x) = @_;
    		eval q(( &L2_AP0($x) |  &L2_AP1($x) |  &L2_AP2($x) |  &L2_AP3($x)));
	    }' unless defined(&L2_AP);
	    if(defined(&CPU_XSCALE_81342)) {
		eval 'sub CPU_XSCALE_CORE3 () {1;}' unless defined(&CPU_XSCALE_CORE3);
		eval 'sub PMAP_NEEDS_PTE_SYNC () {1;}' unless defined(&PMAP_NEEDS_PTE_SYNC);
		eval 'sub PMAP_INCLUDE_PTE_SYNC () {1;}' unless defined(&PMAP_INCLUDE_PTE_SYNC);
	    } else {
		eval 'sub PMAP_NEEDS_PTE_SYNC () {0;}' unless defined(&PMAP_NEEDS_PTE_SYNC);
	    }
	    eval 'sub L1_S_PROT_U () {( &L1_S_AP( &AP_U));}' unless defined(&L1_S_PROT_U);
	    eval 'sub L1_S_PROT_W () {( &L1_S_AP( &AP_W));}' unless defined(&L1_S_PROT_W);
	    eval 'sub L1_S_PROT_MASK () {( &L1_S_PROT_U| &L1_S_PROT_W);}' unless defined(&L1_S_PROT_MASK);
	    eval 'sub L1_S_WRITABLE {
	        my($pd) = @_;
    		eval q((($pd) &  &L1_S_PROT_W));
	    }' unless defined(&L1_S_WRITABLE);
	    eval 'sub L1_S_PROT {
	        my($ku, $pr) = @_;
    		eval q((((($ku) ==  &PTE_USER) ?  &L1_S_PROT_U : 0) | ((($pr) &  &VM_PROT_WRITE) ?  &L1_S_PROT_W : 0)));
	    }' unless defined(&L1_S_PROT);
	    eval 'sub L2_L_PROT_U () {( &L2_AP( &AP_U));}' unless defined(&L2_L_PROT_U);
	    eval 'sub L2_L_PROT_W () {( &L2_AP( &AP_W));}' unless defined(&L2_L_PROT_W);
	    eval 'sub L2_L_PROT_MASK () {( &L2_L_PROT_U| &L2_L_PROT_W);}' unless defined(&L2_L_PROT_MASK);
	    eval 'sub L2_L_PROT {
	        my($ku, $pr) = @_;
    		eval q((((($ku) ==  &PTE_USER) ?  &L2_L_PROT_U : 0) | ((($pr) &  &VM_PROT_WRITE) ?  &L2_L_PROT_W : 0)));
	    }' unless defined(&L2_L_PROT);
	    eval 'sub L2_S_PROT {
	        my($ku, $pr) = @_;
    		eval q((((($ku) ==  &PTE_USER) ?  &L2_S_PROT_U : 0) | ((($pr) &  &VM_PROT_WRITE) ?  &L2_S_PROT_W : 0)));
	    }' unless defined(&L2_S_PROT);
	    eval 'sub L1_S_MAPPABLE_P {
	        my($va, $pa, $size) = @_;
    		eval q((((($va) | ($pa)) &  &L1_S_OFFSET) == 0 && ($size) >=  &L1_S_SIZE));
	    }' unless defined(&L1_S_MAPPABLE_P);
	    eval 'sub L2_L_MAPPABLE_P {
	        my($va, $pa, $size) = @_;
    		eval q((((($va) | ($pa)) &  &L2_L_OFFSET) == 0 && ($size) >=  &L2_L_SIZE));
	    }' unless defined(&L2_L_MAPPABLE_P);
	    unless(defined(&PMAP_NEEDS_PTE_SYNC)) {
		eval 'sub PMAP_NEEDS_PTE_SYNC () { &pmap_needs_pte_sync;}' unless defined(&PMAP_NEEDS_PTE_SYNC);
		eval 'sub PMAP_INCLUDE_PTE_SYNC () {1;}' unless defined(&PMAP_INCLUDE_PTE_SYNC);
	    }
	    if(defined(&ARM_L2_PIPT)) {
		eval 'sub _sync_l2 {
		    my($pte, $size) = @_;
    		    eval q( &cpu_l2cache_wb_range( &vtophys($pte), $size));
		}' unless defined(&_sync_l2);
	    } else {
		eval 'sub _sync_l2 {
		    my($pte, $size) = @_;
    		    eval q( &cpu_l2cache_wb_range($pte, $size));
		}' unless defined(&_sync_l2);
	    }
	    eval 'sub PTE_SYNC {
	        my($pte) = @_;
    		eval q( &do {  &if ( &PMAP_NEEDS_PTE_SYNC) {  &cpu_dcache_wb_range(( &vm_offset_t)($pte), $sizeof{ &pt_entry_t});  &cpu_drain_writebuf();  &_sync_l2(( &vm_offset_t)($pte), $sizeof{ &pt_entry_t}); }  &else  &cpu_drain_writebuf(); }  &while ( 0));
	    }' unless defined(&PTE_SYNC);
	    eval 'sub PTE_SYNC_RANGE {
	        my($pte, $cnt) = @_;
    		eval q( &do {  &if ( &PMAP_NEEDS_PTE_SYNC) {  &cpu_dcache_wb_range(( &vm_offset_t)($pte), ($cnt) << 2);  &cpu_drain_writebuf();  &_sync_l2(( &vm_offset_t)($pte), ($cnt) << 2); }  &else  &cpu_drain_writebuf(); }  &while ( 0));
	    }' unless defined(&PTE_SYNC_RANGE);
	    eval 'sub PTE_KERNEL () {0;}' unless defined(&PTE_KERNEL);
	    eval 'sub PTE_USER () {1;}' unless defined(&PTE_USER);
	    eval 'sub PVF_MOD () {0x1;}' unless defined(&PVF_MOD);
	    eval 'sub PVF_REF () {0x2;}' unless defined(&PVF_REF);
	    eval 'sub PVF_WIRED () {0x4;}' unless defined(&PVF_WIRED);
	    eval 'sub PVF_WRITE () {0x8;}' unless defined(&PVF_WRITE);
	    eval 'sub PVF_EXEC () {0x10;}' unless defined(&PVF_EXEC);
	    eval 'sub PVF_NC () {0x20;}' unless defined(&PVF_NC);
	    eval 'sub PVF_MWC () {0x40;}' unless defined(&PVF_MWC);
	    eval 'sub PVF_UNMAN () {0x80;}' unless defined(&PVF_UNMAN);
	    eval 'sub SECTION_CACHE () {0x1;}' unless defined(&SECTION_CACHE);
	    eval 'sub SECTION_PT () {0x2;}' unless defined(&SECTION_PT);
	}
    }
}
1;
