require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PMAP_VAR_H_)) {
    eval 'sub _MACHINE_PMAP_VAR_H_ () {1;}' unless defined(&_MACHINE_PMAP_VAR_H_);
    require 'machine/cpu-v6.ph';
    require 'machine/pte-v6.ph';
    eval 'sub NPG_IN_PT1 () {( &NB_IN_PT1 /  &PAGE_SIZE);}' unless defined(&NPG_IN_PT1);
    eval 'sub NPT2_IN_PG () {( &PAGE_SIZE /  &NB_IN_PT2);}' unless defined(&NPT2_IN_PG);
    eval 'sub NPTE2_IN_PG () {( &NPT2_IN_PG *  &NPTE2_IN_PT2);}' unless defined(&NPTE2_IN_PG);
    if(defined(&_KERNEL)) {
	eval 'sub PT2PG_SHIFT () {2;}' unless defined(&PT2PG_SHIFT);
	eval 'sub PT2PG_MASK () {((1<<  &PT2PG_SHIFT) - 1);}' unless defined(&PT2PG_MASK);
	eval 'sub PT2TAB_ENTRIES () {( &NPTE1_IN_PT1 /  &NPT2_IN_PG);}' unless defined(&PT2TAB_ENTRIES);
	eval 'sub PT2TAB_SHIFT () {( &PTE1_SHIFT +  &PT2PG_SHIFT);}' unless defined(&PT2TAB_SHIFT);
	eval 'sub PT2MAP_SIZE () {( &NPTE1_IN_PT1 *  &NB_IN_PT2);}' unless defined(&PT2MAP_SIZE);
	eval 'sub PT2MAP_SHIFT () { &PTE2_SHIFT;}' unless defined(&PT2MAP_SHIFT);
	eval 'sub pte1_ptr {
	    my($pt1,$va) = @_;
    	    eval q({ ($pt1 +  &pte1_index($va)); });
	}' unless defined(&pte1_ptr);
	eval 'sub pte1_trunc {
	    my($va) = @_;
    	    eval q({ ($va &  &PTE1_FRAME); });
	}' unless defined(&pte1_trunc);
	eval 'sub pte1_roundup {
	    my($va) = @_;
    	    eval q({ (($va +  &PTE1_OFFSET) &  &PTE1_FRAME); });
	}' unless defined(&pte1_roundup);
	unless(defined(&PMAP_PTE_NOCACHE)) {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub pte1_sync_range {
	    my($pte1p,$size) = @_;
    	    eval q({  &dsb(); });
	}' unless defined(&pte1_sync_range);
	eval 'sub pte1_store {
	    my($pte1p,$pte1) = @_;
    	    eval q({  &dmb(); *$pte1p = $pte1;  &pte1_sync($pte1p); });
	}' unless defined(&pte1_store);
	eval 'sub pte1_clear {
	    my($pte1p) = @_;
    	    eval q({  &pte1_store($pte1p, 0); });
	}' unless defined(&pte1_clear);
	eval 'sub pte1_clear_bit {
	    my($pte1p,$bit) = @_;
    	    eval q({ *$pte1p &= ~$bit;  &pte1_sync($pte1p); });
	}' unless defined(&pte1_clear_bit);
	eval 'sub pte1_is_link {
	    my($pte1) = @_;
    	    eval q({ (($pte1 &  &L1_TYPE_MASK) ==  &L1_TYPE_C); });
	}' unless defined(&pte1_is_link);
	eval 'sub pte1_is_section {
	    my($pte1) = @_;
    	    eval q({ (($pte1 &  &L1_TYPE_MASK) ==  &L1_TYPE_S); });
	}' unless defined(&pte1_is_section);
	eval 'sub pte1_is_dirty {
	    my($pte1) = @_;
    	    eval q({ (($pte1 & ( &PTE1_NM |  &PTE1_RO)) == 0); });
	}' unless defined(&pte1_is_dirty);
	eval 'sub pte1_is_global {
	    my($pte1) = @_;
    	    eval q({ (($pte1 &  &PTE1_NG) == 0); });
	}' unless defined(&pte1_is_global);
	eval 'sub pte1_is_valid {
	    my($pte1) = @_;
    	    eval q({ \'int\'  &l1_type;  &l1_type = $pte1 &  &L1_TYPE_MASK; (( &l1_type ==  &L1_TYPE_C) || ( &l1_type ==  &L1_TYPE_S)); });
	}' unless defined(&pte1_is_valid);
	eval 'sub pte1_is_wired {
	    my($pte1) = @_;
    	    eval q({ ($pte1 &  &PTE1_W); });
	}' unless defined(&pte1_is_wired);
	eval 'sub pte1_load {
	    my($pte1p) = @_;
    	    eval q({  &pt1_entry_t  &pte1;  &pte1 = *$pte1p; ( &pte1); });
	}' unless defined(&pte1_load);
	eval 'sub pte1_load_clear {
	    my($pte1p) = @_;
    	    eval q({  &pt1_entry_t  &opte1;  &opte1 = *$pte1p; *$pte1p = 0;  &pte1_sync($pte1p); ( &opte1); });
	}' unless defined(&pte1_load_clear);
	eval 'sub pte1_set_bit {
	    my($pte1p,$bit) = @_;
    	    eval q({ *$pte1p |= $bit;  &pte1_sync($pte1p); });
	}' unless defined(&pte1_set_bit);
	eval 'sub pte1_pa {
	    my($pte1) = @_;
    	    eval q({ (( &vm_paddr_t)($pte1 &  &PTE1_FRAME)); });
	}' unless defined(&pte1_pa);
	eval 'sub pte1_link_pa {
	    my($pte1) = @_;
    	    eval q({ (( &vm_paddr_t)($pte1 &  &L1_C_ADDR_MASK)); });
	}' unless defined(&pte1_link_pa);
	unless(defined(&PMAP_PTE_NOCACHE)) {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub pte2_sync_range {
	    my($pte2p,$size) = @_;
    	    eval q({  &dsb(); });
	}' unless defined(&pte2_sync_range);
	eval 'sub pte2_store {
	    my($pte2p,$pte2) = @_;
    	    eval q({  &dmb(); *$pte2p = $pte2;  &pte2_sync($pte2p); });
	}' unless defined(&pte2_store);
	eval 'sub pte2_clear {
	    my($pte2p) = @_;
    	    eval q({  &pte2_store($pte2p, 0); });
	}' unless defined(&pte2_clear);
	eval 'sub pte2_clear_bit {
	    my($pte2p,$bit) = @_;
    	    eval q({ *$pte2p &= ~$bit;  &pte2_sync($pte2p); });
	}' unless defined(&pte2_clear_bit);
	eval 'sub pte2_is_dirty {
	    my($pte2) = @_;
    	    eval q({ (($pte2 & ( &PTE2_NM |  &PTE2_RO)) == 0); });
	}' unless defined(&pte2_is_dirty);
	eval 'sub pte2_is_global {
	    my($pte2) = @_;
    	    eval q({ (($pte2 &  &PTE2_NG) == 0); });
	}' unless defined(&pte2_is_global);
	eval 'sub pte2_is_valid {
	    my($pte2) = @_;
    	    eval q({ ($pte2 &  &PTE2_V); });
	}' unless defined(&pte2_is_valid);
	eval 'sub pte2_is_wired {
	    my($pte2) = @_;
    	    eval q({ ($pte2 &  &PTE2_W); });
	}' unless defined(&pte2_is_wired);
	eval 'sub pte2_load {
	    my($pte2p) = @_;
    	    eval q({  &pt2_entry_t  &pte2;  &pte2 = *$pte2p; ( &pte2); });
	}' unless defined(&pte2_load);
	eval 'sub pte2_load_clear {
	    my($pte2p) = @_;
    	    eval q({  &pt2_entry_t  &opte2;  &opte2 = *$pte2p; *$pte2p = 0;  &pte2_sync($pte2p); ( &opte2); });
	}' unless defined(&pte2_load_clear);
	eval 'sub pte2_set_bit {
	    my($pte2p,$bit) = @_;
    	    eval q({ *$pte2p |= $bit;  &pte2_sync($pte2p); });
	}' unless defined(&pte2_set_bit);
	eval 'sub pte2_set_wired {
	    my($pte2p,$wired) = @_;
    	    eval q({  &if ($wired) *$pte2p |=  &PTE2_W;  &else *$pte2p &= ~ &PTE2_W; });
	}' unless defined(&pte2_set_wired);
	eval 'sub pte2_pa {
	    my($pte2) = @_;
    	    eval q({ (( &vm_paddr_t)($pte2 &  &PTE2_FRAME)); });
	}' unless defined(&pte2_pa);
	eval 'sub pte2_attr {
	    my($pte2) = @_;
    	    eval q({ (($pte2 &  &PTE2_ATTR_MASK)); });
	}' unless defined(&pte2_attr);
	eval 'sub pt2tab_entry {
	    my($pt2tab,$va) = @_;
    	    eval q({ ($pt2tab +  &pt2tab_index($va)); });
	}' unless defined(&pt2tab_entry);
	eval 'sub pt2tab_store {
	    my($pte2p,$pte2) = @_;
    	    eval q({  &pte2_store($pte2p,$pte2); });
	}' unless defined(&pt2tab_store);
	eval 'sub pt2tab_load {
	    my($pte2p) = @_;
    	    eval q({ ( &pte2_load($pte2p)); });
	}' unless defined(&pt2tab_load);
	eval 'sub pt2tab_load_clear {
	    my($pte2p) = @_;
    	    eval q({ ( &pte2_load_clear($pte2p)); });
	}' unless defined(&pt2tab_load_clear);
	eval 'sub pt2map_index {
	    my($va) = @_;
    	    eval q({ ($va >>  &PT2MAP_SHIFT); });
	}' unless defined(&pt2map_index);
	eval 'sub pt2map_entry {
	    my($va) = @_;
    	    eval q({ ( &PT2MAP +  &pt2map_index($va)); });
	}' unless defined(&pt2map_entry);
	eval 'sub kern_pte1 {
	    my($va) = @_;
    	    eval q({ ( &pte1_ptr( &kern_pt1, $va)); });
	}' unless defined(&kern_pte1);
	eval 'sub pmap_pt2tab_entry {
	    my($pmap,$va) = @_;
    	    eval q({ ( &pt2tab_entry( ($pmap->{pm_pt2tab}), $va)); });
	}' unless defined(&pmap_pt2tab_entry);
	eval 'sub kern_pt2tab_entry {
	    my($va) = @_;
    	    eval q({ ( &pt2tab_entry( &kern_pt2tab, $va)); });
	}' unless defined(&kern_pt2tab_entry);
	eval 'sub pmap_pt2_page {
	    my($pmap,$va) = @_;
    	    eval q({  &pt2_entry_t  &pte2;  &pte2 =  &pte2_load( &pmap_pt2tab_entry($pmap, $va)); ( &PHYS_TO_VM_PAGE( &pte2 &  &PTE2_FRAME)); });
	}' unless defined(&pmap_pt2_page);
	eval 'sub kern_pt2_page {
	    my($va) = @_;
    	    eval q({  &pt2_entry_t  &pte2;  &pte2 =  &pte2_load( &kern_pt2tab_entry($va)); ( &PHYS_TO_VM_PAGE( &pte2 &  &PTE2_FRAME)); });
	}' unless defined(&kern_pt2_page);
    }
}
1;
