require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MACHINE_SYSREG_H)) {
    eval 'sub MACHINE_SYSREG_H () {1;}' unless defined(&MACHINE_SYSREG_H);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	eval 'sub CP14_DBGDIDR {
	    my($rr) = @_;
    	    eval q( &p14, 0, $rr,  &c0,  &c0, 0);
	}' unless defined(&CP14_DBGDIDR);
	eval 'sub CP14_DBGDSCRext_V6 {
	    my($rr) = @_;
    	    eval q( &p14, 0, $rr,  &c0,  &c1, 0);
	}' unless defined(&CP14_DBGDSCRext_V6);
	eval 'sub CP14_DBGDSCRext_V7 {
	    my($rr) = @_;
    	    eval q( &p14, 0, $rr,  &c0,  &c2, 2);
	}' unless defined(&CP14_DBGDSCRext_V7);
	eval 'sub CP14_DBGVCR {
	    my($rr) = @_;
    	    eval q( &p14, 0, $rr,  &c0,  &c7, 0);
	}' unless defined(&CP14_DBGVCR);
	eval 'sub CP14_DBGOSLAR {
	    my($rr) = @_;
    	    eval q( &p14, 0, $rr,  &c1,  &c0, 4);
	}' unless defined(&CP14_DBGOSLAR);
	eval 'sub CP14_DBGOSLSR {
	    my($rr) = @_;
    	    eval q( &p14, 0, $rr,  &c1,  &c1, 4);
	}' unless defined(&CP14_DBGOSLSR);
	eval 'sub CP14_DBGOSDLR {
	    my($rr) = @_;
    	    eval q( &p14, 0, $rr,  &c1,  &c3, 4);
	}' unless defined(&CP14_DBGOSDLR);
	eval 'sub CP14_DBGPRSR {
	    my($rr) = @_;
    	    eval q( &p14, 0, $rr,  &c1,  &c5, 4);
	}' unless defined(&CP14_DBGPRSR);
	eval 'sub CP14_DBGDSCRint {
	    my($rr) = @_;
    	    eval q( &CP14_DBGDSCRext_V6($rr));
	}' unless defined(&CP14_DBGDSCRint);
    }
    eval 'sub CP15_MIDR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c0, 0);
    }' unless defined(&CP15_MIDR);
    eval 'sub CP15_CTR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c0, 1);
    }' unless defined(&CP15_CTR);
    eval 'sub CP15_TCMTR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c0, 2);
    }' unless defined(&CP15_TCMTR);
    eval 'sub CP15_TLBTR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c0, 3);
    }' unless defined(&CP15_TLBTR);
    eval 'sub CP15_MPIDR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c0, 5);
    }' unless defined(&CP15_MPIDR);
    eval 'sub CP15_REVIDR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c0, 6);
    }' unless defined(&CP15_REVIDR);
    eval 'sub CP15_ID_PFR0 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c1, 0);
    }' unless defined(&CP15_ID_PFR0);
    eval 'sub CP15_ID_PFR1 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c1, 1);
    }' unless defined(&CP15_ID_PFR1);
    eval 'sub CP15_ID_DFR0 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c1, 2);
    }' unless defined(&CP15_ID_DFR0);
    eval 'sub CP15_ID_AFR0 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c1, 3);
    }' unless defined(&CP15_ID_AFR0);
    eval 'sub CP15_ID_MMFR0 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c1, 4);
    }' unless defined(&CP15_ID_MMFR0);
    eval 'sub CP15_ID_MMFR1 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c1, 5);
    }' unless defined(&CP15_ID_MMFR1);
    eval 'sub CP15_ID_MMFR2 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c1, 6);
    }' unless defined(&CP15_ID_MMFR2);
    eval 'sub CP15_ID_MMFR3 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c1, 7);
    }' unless defined(&CP15_ID_MMFR3);
    eval 'sub CP15_ID_ISAR0 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c2, 0);
    }' unless defined(&CP15_ID_ISAR0);
    eval 'sub CP15_ID_ISAR1 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c2, 1);
    }' unless defined(&CP15_ID_ISAR1);
    eval 'sub CP15_ID_ISAR2 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c2, 2);
    }' unless defined(&CP15_ID_ISAR2);
    eval 'sub CP15_ID_ISAR3 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c2, 3);
    }' unless defined(&CP15_ID_ISAR3);
    eval 'sub CP15_ID_ISAR4 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c2, 4);
    }' unless defined(&CP15_ID_ISAR4);
    eval 'sub CP15_ID_ISAR5 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c0,  &c2, 5);
    }' unless defined(&CP15_ID_ISAR5);
    eval 'sub CP15_CCSIDR {
        my($rr) = @_;
	    eval q( &p15, 1, $rr,  &c0,  &c0, 0);
    }' unless defined(&CP15_CCSIDR);
    eval 'sub CP15_CLIDR {
        my($rr) = @_;
	    eval q( &p15, 1, $rr,  &c0,  &c0, 1);
    }' unless defined(&CP15_CLIDR);
    eval 'sub CP15_AIDR {
        my($rr) = @_;
	    eval q( &p15, 1, $rr,  &c0,  &c0, 7);
    }' unless defined(&CP15_AIDR);
    eval 'sub CP15_CSSELR {
        my($rr) = @_;
	    eval q( &p15, 2, $rr,  &c0,  &c0, 0);
    }' unless defined(&CP15_CSSELR);
    eval 'sub CP15_VPIDR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c0,  &c0, 0);
    }' unless defined(&CP15_VPIDR);
    eval 'sub CP15_VMPIDR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c0,  &c0, 5);
    }' unless defined(&CP15_VMPIDR);
    eval 'sub CP15_SCTLR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c1,  &c0, 0);
    }' unless defined(&CP15_SCTLR);
    eval 'sub CP15_ACTLR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c1,  &c0, 1);
    }' unless defined(&CP15_ACTLR);
    eval 'sub CP15_CPACR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c1,  &c0, 2);
    }' unless defined(&CP15_CPACR);
    eval 'sub CP15_SCR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c1,  &c1, 0);
    }' unless defined(&CP15_SCR);
    eval 'sub CP15_SDER {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c1,  &c1, 1);
    }' unless defined(&CP15_SDER);
    eval 'sub CP15_NSACR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c1,  &c1, 2);
    }' unless defined(&CP15_NSACR);
    eval 'sub CP15_HSCTLR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c1,  &c0, 0);
    }' unless defined(&CP15_HSCTLR);
    eval 'sub CP15_HCR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c1,  &c1, 0);
    }' unless defined(&CP15_HCR);
    eval 'sub CP15_HDCR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c1,  &c1, 1);
    }' unless defined(&CP15_HDCR);
    eval 'sub CP15_HCPTR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c1,  &c1, 2);
    }' unless defined(&CP15_HCPTR);
    eval 'sub CP15_HSTR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c1,  &c1, 3);
    }' unless defined(&CP15_HSTR);
    eval 'sub CP15_TTBR0 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c2,  &c0, 0);
    }' unless defined(&CP15_TTBR0);
    eval 'sub CP15_TTBR1 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c2,  &c0, 1);
    }' unless defined(&CP15_TTBR1);
    eval 'sub CP15_TTBCR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c2,  &c0, 2);
    }' unless defined(&CP15_TTBCR);
    eval 'sub CP15_HTCR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c2,  &c0, 2);
    }' unless defined(&CP15_HTCR);
    eval 'sub CP15_VTCR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c2,  &c1, 2);
    }' unless defined(&CP15_VTCR);
    eval 'sub CP15_DACR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c3,  &c0, 0);
    }' unless defined(&CP15_DACR);
    eval 'sub CP15_DFSR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c5,  &c0, 0);
    }' unless defined(&CP15_DFSR);
    eval 'sub CP15_HSR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c5,  &c2, 0);
    }' unless defined(&CP15_HSR);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	eval 'sub CP15_IFSR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c5,  &c0, 1);
	}' unless defined(&CP15_IFSR);
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7) {
	eval 'sub CP15_ADFSR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c5,  &c1, 0);
	}' unless defined(&CP15_ADFSR);
	eval 'sub CP15_AIFSR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c5,  &c1, 1);
	}' unless defined(&CP15_AIFSR);
    }
    eval 'sub CP15_DFAR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c6,  &c0, 0);
    }' unless defined(&CP15_DFAR);
    eval 'sub CP15_HDFAR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c6,  &c0, 0);
    }' unless defined(&CP15_HDFAR);
    eval 'sub CP15_HIFAR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c6,  &c0, 2);
    }' unless defined(&CP15_HIFAR);
    eval 'sub CP15_HPFAR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c6,  &c0, 4);
    }' unless defined(&CP15_HPFAR);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	eval 'sub CP15_IFAR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c6,  &c0, 2);
	}' unless defined(&CP15_IFAR);
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7 && defined(&SMP)) {
	eval 'sub CP15_ICIALLUIS () { &p15, 0,  &r0,  &c7,  &c1, 0;}' unless defined(&CP15_ICIALLUIS);
	eval 'sub CP15_BPIALLIS () { &p15, 0,  &r0,  &c7,  &c1, 6;}' unless defined(&CP15_BPIALLIS);
    }
    eval 'sub CP15_PAR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c4, 0);
    }' unless defined(&CP15_PAR);
    eval 'sub CP15_ICIALLU () { &p15, 0,  &r0,  &c7,  &c5, 0;}' unless defined(&CP15_ICIALLU);
    eval 'sub CP15_ICIMVAU {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c5, 1);
    }' unless defined(&CP15_ICIMVAU);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) == 6) {
	eval 'sub CP15_CP15ISB () { &p15, 0,  &r0,  &c7,  &c5, 4;}' unless defined(&CP15_CP15ISB);
    }
    eval 'sub CP15_BPIALL () { &p15, 0,  &r0,  &c7,  &c5, 6;}' unless defined(&CP15_BPIALL);
    eval 'sub CP15_BPIMVA () { &p15, 0,  &rr,  &c7,  &c5, 7;}' unless defined(&CP15_BPIMVA);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) == 6) {
	eval 'sub CP15_DCIALL () { &p15, 0,  &r0,  &c7,  &c6, 0;}' unless defined(&CP15_DCIALL);
    }
    eval 'sub CP15_DCIMVAC {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c6, 1);
    }' unless defined(&CP15_DCIMVAC);
    eval 'sub CP15_DCISW {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c6, 2);
    }' unless defined(&CP15_DCISW);
    eval 'sub CP15_ATS1CPR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c8, 0);
    }' unless defined(&CP15_ATS1CPR);
    eval 'sub CP15_ATS1CPW {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c8, 1);
    }' unless defined(&CP15_ATS1CPW);
    eval 'sub CP15_ATS1CUR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c8, 2);
    }' unless defined(&CP15_ATS1CUR);
    eval 'sub CP15_ATS1CUW {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c8, 3);
    }' unless defined(&CP15_ATS1CUW);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7) {
	eval 'sub CP15_ATS12NSOPR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c7,  &c8, 4);
	}' unless defined(&CP15_ATS12NSOPR);
	eval 'sub CP15_ATS12NSOPW {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c7,  &c8, 5);
	}' unless defined(&CP15_ATS12NSOPW);
	eval 'sub CP15_ATS12NSOUR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c7,  &c8, 6);
	}' unless defined(&CP15_ATS12NSOUR);
	eval 'sub CP15_ATS12NSOUW {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c7,  &c8, 7);
	}' unless defined(&CP15_ATS12NSOUW);
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) == 6) {
	eval 'sub CP15_DCCALL () { &p15, 0,  &r0,  &c7,  &c10, 0;}' unless defined(&CP15_DCCALL);
    }
    eval 'sub CP15_DCCMVAC {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c10, 1);
    }' unless defined(&CP15_DCCMVAC);
    eval 'sub CP15_DCCSW {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c10, 2);
    }' unless defined(&CP15_DCCSW);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) == 6) {
	eval 'sub CP15_CP15DSB () { &p15, 0,  &r0,  &c7,  &c10, 4;}' unless defined(&CP15_CP15DSB);
	eval 'sub CP15_CP15DMB () { &p15, 0,  &r0,  &c7,  &c10, 5;}' unless defined(&CP15_CP15DMB);
	eval 'sub CP15_CP15WFI () { &p15, 0,  &r0,  &c7,  &c0, 4;}' unless defined(&CP15_CP15WFI);
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7) {
	eval 'sub CP15_DCCMVAU {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c7,  &c11, 1);
	}' unless defined(&CP15_DCCMVAU);
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) == 6) {
	eval 'sub CP15_DCCIALL () { &p15, 0,  &r0,  &c7,  &c14, 0;}' unless defined(&CP15_DCCIALL);
    }
    eval 'sub CP15_DCCIMVAC {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c14, 1);
    }' unless defined(&CP15_DCCIMVAC);
    eval 'sub CP15_DCCISW {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c7,  &c14, 2);
    }' unless defined(&CP15_DCCISW);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 7 && defined(&SMP)) {
	eval 'sub CP15_TLBIALLIS () { &p15, 0,  &r0,  &c8,  &c3, 0;}' unless defined(&CP15_TLBIALLIS);
	eval 'sub CP15_TLBIMVAIS {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c8,  &c3, 1);
	}' unless defined(&CP15_TLBIMVAIS);
	eval 'sub CP15_TLBIASIDIS {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c8,  &c3, 2);
	}' unless defined(&CP15_TLBIASIDIS);
	eval 'sub CP15_TLBIMVAAIS {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c8,  &c3, 3);
	}' unless defined(&CP15_TLBIMVAAIS);
    }
    eval 'sub CP15_TLBIALL () { &p15, 0,  &r0,  &c8,  &c7, 0;}' unless defined(&CP15_TLBIALL);
    eval 'sub CP15_TLBIMVA {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c8,  &c7, 1);
    }' unless defined(&CP15_TLBIMVA);
    eval 'sub CP15_TLBIASID {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c8,  &c7, 2);
    }' unless defined(&CP15_TLBIASID);
    eval 'sub CP15_TLBIALLH {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c8,  &c7, 0);
    }' unless defined(&CP15_TLBIALLH);
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) >= 6) {
	eval 'sub CP15_TLBIMVAA {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c8,  &c7, 3);
	}' unless defined(&CP15_TLBIMVAA);
    }
    if((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) == 6 && defined(&CPU_ARM1176)) {
	eval 'sub CP15_PMUSERENR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c15,  &c9, 0);
	}' unless defined(&CP15_PMUSERENR);
	eval 'sub CP15_PMCR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c15,  &c12, 0);
	}' unless defined(&CP15_PMCR);
	eval 'sub CP15_PMCCNTR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c15,  &c12, 1);
	}' unless defined(&CP15_PMCCNTR);
    }
 elsif((defined(&__ARM_ARCH) ? &__ARM_ARCH : undef) > 6) {
	eval 'sub CP15_L2CTLR {
	    my($rr) = @_;
    	    eval q( &p15, 1, $rr,  &c9,  &c0, 2);
	}' unless defined(&CP15_L2CTLR);
	eval 'sub CP15_PMCR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c12, 0);
	}' unless defined(&CP15_PMCR);
	eval 'sub CP15_PMCNTENSET {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c12, 1);
	}' unless defined(&CP15_PMCNTENSET);
	eval 'sub CP15_PMCNTENCLR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c12, 2);
	}' unless defined(&CP15_PMCNTENCLR);
	eval 'sub CP15_PMOVSR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c12, 3);
	}' unless defined(&CP15_PMOVSR);
	eval 'sub CP15_PMSWINC {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c12, 4);
	}' unless defined(&CP15_PMSWINC);
	eval 'sub CP15_PMSELR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c12, 5);
	}' unless defined(&CP15_PMSELR);
	eval 'sub CP15_PMCCNTR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c13, 0);
	}' unless defined(&CP15_PMCCNTR);
	eval 'sub CP15_PMXEVTYPER {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c13, 1);
	}' unless defined(&CP15_PMXEVTYPER);
	eval 'sub CP15_PMXEVCNTRR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c13, 2);
	}' unless defined(&CP15_PMXEVCNTRR);
	eval 'sub CP15_PMUSERENR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c14, 0);
	}' unless defined(&CP15_PMUSERENR);
	eval 'sub CP15_PMINTENSET {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c14, 1);
	}' unless defined(&CP15_PMINTENSET);
	eval 'sub CP15_PMINTENCLR {
	    my($rr) = @_;
    	    eval q( &p15, 0, $rr,  &c9,  &c14, 2);
	}' unless defined(&CP15_PMINTENCLR);
    }
    eval 'sub CP15_PRRR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c10,  &c2, 0);
    }' unless defined(&CP15_PRRR);
    eval 'sub CP15_MAIR0 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c10,  &c2, 0);
    }' unless defined(&CP15_MAIR0);
    eval 'sub CP15_NMRR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c10,  &c2, 1);
    }' unless defined(&CP15_NMRR);
    eval 'sub CP15_MAIR1 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c10,  &c2, 1);
    }' unless defined(&CP15_MAIR1);
    eval 'sub CP15_AMAIR0 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c10,  &c3, 0);
    }' unless defined(&CP15_AMAIR0);
    eval 'sub CP15_AMAIR1 {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c10,  &c3, 1);
    }' unless defined(&CP15_AMAIR1);
    eval 'sub CP15_HMAIR0 {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c10,  &c2, 0);
    }' unless defined(&CP15_HMAIR0);
    eval 'sub CP15_HMAIR1 {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c10,  &c2, 1);
    }' unless defined(&CP15_HMAIR1);
    eval 'sub CP15_VBAR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c12,  &c0, 0);
    }' unless defined(&CP15_VBAR);
    eval 'sub CP15_MVBAR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c12,  &c0, 1);
    }' unless defined(&CP15_MVBAR);
    eval 'sub CP15_ISR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c12,  &c1, 0);
    }' unless defined(&CP15_ISR);
    eval 'sub CP15_HVBAR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c12,  &c0, 0);
    }' unless defined(&CP15_HVBAR);
    eval 'sub CP15_FCSEIDR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c13,  &c0, 0);
    }' unless defined(&CP15_FCSEIDR);
    eval 'sub CP15_CONTEXTIDR {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c13,  &c0, 1);
    }' unless defined(&CP15_CONTEXTIDR);
    eval 'sub CP15_TPIDRURW {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c13,  &c0, 2);
    }' unless defined(&CP15_TPIDRURW);
    eval 'sub CP15_TPIDRURO {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c13,  &c0, 3);
    }' unless defined(&CP15_TPIDRURO);
    eval 'sub CP15_TPIDRPRW {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c13,  &c0, 4);
    }' unless defined(&CP15_TPIDRPRW);
    eval 'sub CP15_HTPIDR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c13,  &c0, 2);
    }' unless defined(&CP15_HTPIDR);
    eval 'sub CP15_CNTFRQ {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c14,  &c0, 0);
    }' unless defined(&CP15_CNTFRQ);
    eval 'sub CP15_CNTKCTL {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c14,  &c1, 0);
    }' unless defined(&CP15_CNTKCTL);
    eval 'sub CP15_CNTP_TVAL {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c14,  &c2, 0);
    }' unless defined(&CP15_CNTP_TVAL);
    eval 'sub CP15_CNTP_CTL {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c14,  &c2, 1);
    }' unless defined(&CP15_CNTP_CTL);
    eval 'sub CP15_CNTV_TVAL {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c14,  &c3, 0);
    }' unless defined(&CP15_CNTV_TVAL);
    eval 'sub CP15_CNTV_CTL {
        my($rr) = @_;
	    eval q( &p15, 0, $rr,  &c14,  &c3, 1);
    }' unless defined(&CP15_CNTV_CTL);
    eval 'sub CP15_CNTHCTL {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c14,  &c1, 0);
    }' unless defined(&CP15_CNTHCTL);
    eval 'sub CP15_CNTHP_TVAL {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c14,  &c2, 0);
    }' unless defined(&CP15_CNTHP_TVAL);
    eval 'sub CP15_CNTHP_CTL {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c14,  &c2, 1);
    }' unless defined(&CP15_CNTHP_CTL);
    eval 'sub CP15_CNTPCT {
        my($rq, $rr) = @_;
	    eval q( &p15, 0, $rq, $rr,  &c14);
    }' unless defined(&CP15_CNTPCT);
    eval 'sub CP15_CNTVCT {
        my($rq, $rr) = @_;
	    eval q( &p15, 1, $rq, $rr,  &c14);
    }' unless defined(&CP15_CNTVCT);
    eval 'sub CP15_CNTP_CVAL {
        my($rq, $rr) = @_;
	    eval q( &p15, 2, $rq, $rr,  &c14);
    }' unless defined(&CP15_CNTP_CVAL);
    eval 'sub CP15_CNTV_CVAL {
        my($rq, $rr) = @_;
	    eval q( &p15, 3, $rq, $rr,  &c14);
    }' unless defined(&CP15_CNTV_CVAL);
    eval 'sub CP15_CNTVOFF {
        my($rq, $rr) = @_;
	    eval q( &p15, 4, $rq, $rr,  &c14);
    }' unless defined(&CP15_CNTVOFF);
    eval 'sub CP15_CNTHP_CVAL {
        my($rq, $rr) = @_;
	    eval q( &p15, 6, $rq, $rr,  &c14);
    }' unless defined(&CP15_CNTHP_CVAL);
    eval 'sub CP15_VTTBR {
        my($rq, $rr) = @_;
	    eval q( &p15, 6, $rq, $rr,  &c2);
    }' unless defined(&CP15_VTTBR);
    eval 'sub CP15_HTTBR {
        my($rq, $rr) = @_;
	    eval q( &p15, 4, $rq, $rr,  &c2);
    }' unless defined(&CP15_HTTBR);
    eval 'sub CP15_TTBR0_2 {
        my($rq, $rr) = @_;
	    eval q( &p15, 0, $rq, $rr,  &c2);
    }' unless defined(&CP15_TTBR0_2);
    eval 'sub CP15_TTBR1_2 {
        my($rq, $rr) = @_;
	    eval q( &p15, 1, $rq, $rr,  &c2);
    }' unless defined(&CP15_TTBR1_2);
    eval 'sub CP15_PAR_2 {
        my($rq, $rr) = @_;
	    eval q( &p15, 0, $rq, $rr,  &c7);
    }' unless defined(&CP15_PAR_2);
    eval 'sub CP15_CBAR {
        my($rr) = @_;
	    eval q( &p15, 4, $rr,  &c15,  &c0, 0);
    }' unless defined(&CP15_CBAR);
}
1;
